# include "DerivedTypes.h"
# include "yyDerivedTypes.w"
# include "System.h"
# include <stdio.h>
# include "Tree.h"
# include "Definitions.h"

# ifndef NULL
# define NULL 0L
# endif
# ifndef false
# define false 0
# endif
# ifndef true
# define true 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) \
  if ((ptr = (tree) free) >= (tree) max) ptr = alloc (); \
  free += nodesize [kind]; \
  ptr->yyHead.yyMark = 0; \
  ptr->Kind = kind;
# else
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) ptr = make (kind);
# endif

# define yyWrite(s) (void) fputs (s, yyf)
# define yyWriteNl (void) fputc ('\n', yyf)

# line 20 "DerivedTypes.puma"


# include <stdio.h>
# include "Idents.h"
# include "StringMem.h"
 
# include "protocol.h"

# include "Types.h"

# define MODULE "DerivedTypes"
 
# undef DEBUG



static void yyExit () { Exit (1); }

void (* DerivedTypes_Exit) () = yyExit;

static FILE * yyf = stdout;

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module DerivedTypes, routine %s failed\n", yyFunction);
 DerivedTypes_Exit ();
}

bool IsExplicitlyMappedType ARGS((tTree t));
bool IsExplicitlyMappedTypeObj ARGS((tDefinitions t));
static bool HasMappedEntry ARGS((tDefinitions comps));
static bool IsMappedEntry ARGS((tDefinitions v));

bool IsExplicitlyMappedType
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
  if (t->Kind == kTYPE_ID) {
# line 45 "DerivedTypes.puma"
  {
# line 47 "DerivedTypes.puma"
   if (! ((IsExplicitlyMappedTypeObj (t->TYPE_ID.ID->TYPE_OBJ.Object)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  return false;
}

bool IsExplicitlyMappedTypeObj
# if defined __STDC__ | defined __cplusplus
(register tDefinitions t)
# else
(t)
 register tDefinitions t;
# endif
{
# line 52 "DerivedTypes.puma"
  {
# line 54 "DerivedTypes.puma"
   if (! ((HasMappedEntry (t->TypeObject.Components)))) goto yyL1;
  }
   return true;
yyL1:;

  return false;
}

static bool HasMappedEntry
# if defined __STDC__ | defined __cplusplus
(register tDefinitions comps)
# else
(comps)
 register tDefinitions comps;
# endif
{
  if (comps->Kind == kENTRY_LIST) {
# line 64 "DerivedTypes.puma"
  {
# line 66 "DerivedTypes.puma"
   if (! ((IsMappedEntry (comps->ENTRY_LIST.Elem)))) goto yyL1;
  }
   return true;
yyL1:;

# line 69 "DerivedTypes.puma"
  {
# line 71 "DerivedTypes.puma"
   if (! ((HasMappedEntry (comps->ENTRY_LIST.Next)))) goto yyL2;
  }
   return true;
yyL2:;

  }
  return false;
}

static bool IsMappedEntry
# if defined __STDC__ | defined __cplusplus
(register tDefinitions v)
# else
(v)
 register tDefinitions v;
# endif
{
  if (v->Kind == kVarObject) {
  if (v->VarObject.Dist->Kind == kDeclDistribution) {
# line 76 "DerivedTypes.puma"
   return true;

  }
  if (v->VarObject.Dist->Kind == kNodeDistribution) {
# line 79 "DerivedTypes.puma"
   return true;

  }
  if (v->VarObject.decl->Kind == kVAR_DECL) {
# line 82 "DerivedTypes.puma"
  {
# line 84 "DerivedTypes.puma"
   if (! ((IsExplicitlyMappedType (GetBaseType (v->VarObject.decl->VAR_DECL.VAL))))) goto yyL3;
  }
   return true;
yyL3:;

  }
  }
  return false;
}

void BeginDerivedTypes ()
{
}

void CloseDerivedTypes ()
{
}
