# define IFNOTIN(b, s) if (! (s & 1 << b)) {
# define INCL(s, b) s |= 1 << b
# define REMOTE_SYN(i, b, c, n, t, a) (n->yyHead.i & 1 << b ? (void) 0 : c (n), n->t.a)
# define REMOTE_INH(i, b, k, n, t, a) (n->yyHead.i & 1 << b ? (void) 0 : yyI [n->yyHead.yyOffset + k](n->yyHead.yyParent), n->t.a)
# define DEP(a, b) a
# define SELF yyt
# include "Eval.h"


static char yyb;

static void yyE ARGS((register tTree yyt));
static void yyS1 ARGS((register tTree yyt));
static void yyS2 ARGS((register tTree yyt));
static void yyS3 ARGS((register tTree yyt));
static void yyS4 ARGS((register tTree yyt));
static void yyS5 ARGS((register tTree yyt));

static Tree_tProcTree yyI [1] = { 0,
};

static void yyAbort
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fprintf (stderr, "Error: module Eval, cyclic dependencies\n");
 Tree_Exit ();
}

void Eval
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{ InitTree (yyt); yyE (yyt); }

static void yyE
# if defined __STDC__ | defined __cplusplus
 (register tTree yyt)
# else
 (yyt) register tTree yyt;
# endif
{
 for (;;) {
  if (yyt == NoTree || yyt->yyHead.yyIsComp0 & 1) return;
  yyt->yyHead.yyIsComp0 |= 1;
  switch (yyt->Kind) {
  case kCOMP_UNIT:
yyE (yyt->COMP_UNIT.COMP_ELEMENTS);
yyt = yyt->COMP_UNIT.USED_ELEMENTS; break;
  case kUNIT_LIST:
yyE (yyt->UNIT_LIST.Elem);
yyt = yyt->UNIT_LIST.Next; break;
  case kMODULE_DECL:
yyt = yyt->MODULE_DECL.MODULE_BODY; break;
  case kPROGRAM_DECL:
yyE (yyt->PROGRAM_DECL.FORMALS);
yyt = yyt->PROGRAM_DECL.PROGRAM_BODY; break;
  case kPROC_DECL:
yyE (yyt->PROC_DECL.FORMALS);
yyt = yyt->PROC_DECL.PROC_BODY; break;
  case kFUNC_DECL:
yyE (yyt->FUNC_DECL.FORMALS);
yyE (yyt->FUNC_DECL.FUNC_BODY);
yyt = yyt->FUNC_DECL.RESULT_TYPE; break;
  case kBLOCK_DATA_DECL:
yyt = yyt->BLOCK_DATA_DECL.DATA_BODY; break;
  case kINTERFACE:
yyt = yyt->INTERFACE.ITEMS; break;
  case kBODY_NODE:
yyE (yyt->BODY_NODE.DECLS);
yyE (yyt->BODY_NODE.STATS);
yyt = yyt->BODY_NODE.INTERNALS; break;
  case kINTEGER_TYPE:
yyt = yyt->INTEGER_TYPE.SIZE; break;
  case kREAL_TYPE:
yyt = yyt->REAL_TYPE.SIZE; break;
  case kBOOLEAN_TYPE:
yyt = yyt->BOOLEAN_TYPE.SIZE; break;
  case kCOMPLEX_TYPE:
yyt = yyt->COMPLEX_TYPE.SIZE; break;
  case kSTRING_TYPE:
yyt = yyt->STRING_TYPE.LENGTH; break;
  case kTYPE_ID:
yyt = yyt->TYPE_ID.ID; break;
  case kARRAY_TYPE:
yyE (yyt->ARRAY_TYPE.ARRAY_INDEX_TYPES);
yyt = yyt->ARRAY_TYPE.ARRAY_COMP_TYPE; break;
  case kRECORD_TYPE:
yyt = yyt->RECORD_TYPE.COMPONENTS; break;
  case kPOINTER_TYPE:
yyt = yyt->POINTER_TYPE.PTR_COMP; break;
  case kEXPLICIT_SHAPE:
yyE (yyt->EXPLICIT_SHAPE.LOWER);
yyt = yyt->EXPLICIT_SHAPE.UPPER; break;
  case kASSUMED_SHAPE:
yyt = yyt->ASSUMED_SHAPE.LOWER; break;
  case kASSUMED_SIZE:
yyt = yyt->ASSUMED_SIZE.LOWER; break;
  case kSHAPE_LIST:
yyE (yyt->SHAPE_LIST.Elem);
yyt = yyt->SHAPE_LIST.Next; break;
  case kTYPE_DECL:
yyt = yyt->TYPE_DECL.VAL; break;
  case kENTITY_DECL:
yyt = yyt->ENTITY_DECL.ATTRIBUTES; break;
  case kVAR_DECL:
yyt = yyt->VAR_DECL.VAL; break;
  case kCOMMON_DECL:
yyt = yyt->COMMON_DECL.IDS; break;
  case kNAMELIST_DECL:
yyt = yyt->NAMELIST_DECL.IDS; break;
  case kTEMPLATE_DECL:
yyt = yyt->TEMPLATE_DECL.DIMENSIONS; break;
  case kRAGGED_DECL:
yyt = yyt->RAGGED_DECL.DIMENSIONS; break;
  case kPROCESSORS_DECL:
yyt = yyt->PROCESSORS_DECL.DIMENSIONS; break;
  case kSUB_PROCS_DECL:
yyE (yyt->SUB_PROCS_DECL.TOP);
yyt = yyt->SUB_PROCS_DECL.DIMENSIONS; break;
  case kRANGE_DECL:
yyt = yyt->RANGE_DECL.RANGES; break;
  case kSTMT_FUNC_DECL:
yyE (yyt->STMT_FUNC_DECL.FORMALS);
yyE (yyt->STMT_FUNC_DECL.RESULT_TYPE);
yyt = yyt->STMT_FUNC_DECL.FFUNC_BODY; break;
  case kINTERFACE_DECL:
yyt = yyt->INTERFACE_DECL.ITEMS; break;
  case kVAR_PARAM_DECL:
yyt = yyt->VAR_PARAM_DECL.VAL; break;
  case kIMPLICIT_DECL:
yyt = yyt->IMPLICIT_DECL.TYPE; break;
  case kUSE_DECL:
yyt = yyt->USE_DECL.RENAMINGS; break;
  case kONLY_USE_DECL:
yyt = yyt->ONLY_USE_DECL.NAMES; break;
  case kEQV_DECL:
yyt = yyt->EQV_DECL.VARS; break;
  case kDATA_DECL:
yyE (yyt->DATA_DECL.VARS);
yyt = yyt->DATA_DECL.VALS; break;
  case kFORMAT_DECL:
yyt = yyt->FORMAT_DECL.FORMAT_PARAMS; break;
  case kDIMENSION_DECL:
yyt = yyt->DIMENSION_DECL.INDEXES; break;
  case kINIT_DATA_DECL:
yyt = yyt->INIT_DATA_DECL.VAL; break;
  case kTYPESPEC_DECL:
yyt = yyt->TYPESPEC_DECL.VAL; break;
  case kPARAMETER_DECL:
yyt = yyt->PARAMETER_DECL.VAL; break;
  case kDISTRIBUTE_DECL:
yyE (yyt->DISTRIBUTE_DECL.DISTRIBUTION);
yyt = yyt->DISTRIBUTE_DECL.TARGET; break;
  case kALIGN_DECL:
yyE (yyt->ALIGN_DECL.ALIGN_SOURCE);
yyt = yyt->ALIGN_DECL.ALIGN_TARGET; break;
  case kMAP_DECL:
yyt = yyt->MAP_DECL.MAP_TARGET; break;
  case kOVERLAP_DECL:
yyt = yyt->OVERLAP_DECL.OVERLAPS; break;
  case kDECL_LIST:
yyE (yyt->DECL_LIST.Elem);
yyt = yyt->DECL_LIST.Next; break;
  case kRANGE_LIST:
yyE (yyt->RANGE_LIST.Elem);
yyt = yyt->RANGE_LIST.Next; break;
  case kNODE_DISTRIBUTION:
yyt = yyt->NODE_DISTRIBUTION.MAPPING; break;
  case kDIST_LIST:
yyE (yyt->DIST_LIST.Elem);
yyt = yyt->DIST_LIST.Next; break;
  case kBLOCK_DISTRIBUTION:
yyt = yyt->BLOCK_DISTRIBUTION.SIZE; break;
  case kCYCLIC_DISTRIBUTION:
yyt = yyt->CYCLIC_DISTRIBUTION.SIZE; break;
  case kGEN_BLOCK_DISTRIBUTION:
yyt = yyt->GEN_BLOCK_DISTRIBUTION.ARRAY; break;
  case kINDIRECT_DISTRIBUTION:
yyt = yyt->INDIRECT_DISTRIBUTION.ARRAY; break;
  case kARBITRARY_DISTRIBUTION:
yyE (yyt->ARBITRARY_DISTRIBUTION.SIZE);
yyE (yyt->ARBITRARY_DISTRIBUTION.LENGTH);
yyt = yyt->ARBITRARY_DISTRIBUTION.MAP; break;
  case kPROCESSOR_ARRAY:
yyt = yyt->PROCESSOR_ARRAY.TOPNAME; break;
  case kPROCESSOR_SUBSET:
yyE (yyt->PROCESSOR_SUBSET.SUBTOP);
yyE (yyt->PROCESSOR_SUBSET.FULLTOP);
yyt = yyt->PROCESSOR_SUBSET.SUBSCRIPTS; break;
  case kALIGN_SPEC:
yyE (yyt->ALIGN_SPEC.TEMPNAME);
yyt = yyt->ALIGN_SPEC.SUBSCRIPTS; break;
  case kACF_LIST:
yyE (yyt->ACF_LIST.Elem);
yyt = yyt->ACF_LIST.Next; break;
  case kACF_BASIC:
yyt = yyt->ACF_BASIC.BASIC_STMT; break;
  case kACF_IF:
yyE (yyt->ACF_IF.IF_EXP);
yyE (yyt->ACF_IF.THEN_PART);
yyt = yyt->ACF_IF.ELSE_PART; break;
  case kACF_WHERE:
yyE (yyt->ACF_WHERE.WHERE_EXP);
yyE (yyt->ACF_WHERE.TRUE_PART);
yyt = yyt->ACF_WHERE.FALSE_PART; break;
  case kACF_CASE:
yyE (yyt->ACF_CASE.CASE_EXP);
yyt = yyt->ACF_CASE.CASE_ALTS; break;
  case kACF_WHILE:
yyE (yyt->ACF_WHILE.WHILE_EXP);
yyt = yyt->ACF_WHILE.WHILE_BODY; break;
  case kACF_REPEAT:
yyE (yyt->ACF_REPEAT.REPEAT_BODY);
yyt = yyt->ACF_REPEAT.REPEAT_EXP; break;
  case kACF_LOOP:
yyt = yyt->ACF_LOOP.LOOP_BODY; break;
  case kACF_DO:
yyE (yyt->ACF_DO.DO_ID);
yyE (yyt->ACF_DO.DO_RANGE);
yyE (yyt->ACF_DO.DO_BODY);
return;
  case kACF_FORALL:
yyE (yyt->ACF_FORALL.FORALL_ID);
yyE (yyt->ACF_FORALL.FORALL_RANGE);
yyE (yyt->ACF_FORALL.FORALL_BODY);
return;
  case kACF_FLOW_GRAPH:
yyt = yyt->ACF_FLOW_GRAPH.FLOW_NODES; break;
  case kACF_ENTRY:
yyt = yyt->ACF_ENTRY.ENTRY_DECL; break;
  case kACF_HOME:
yyE (yyt->ACF_HOME.HOME_VAR);
yyt = yyt->ACF_HOME.HOME_BODY; break;
  case kACF_RESIDENT:
yyE (yyt->ACF_RESIDENT.RESIDENT_VAR);
yyt = yyt->ACF_RESIDENT.RESIDENT_BODY; break;
  case kACF_NEW:
yyE (yyt->ACF_NEW.NEW_VAR);
yyt = yyt->ACF_NEW.NEW_BODY; break;
  case kACF_REDUCTION:
yyE (yyt->ACF_REDUCTION.REDUCTION_VAR);
yyE (yyt->ACF_REDUCTION.REDUCTION_LVAR);
yyE (yyt->ACF_REDUCTION.REDUCTION_FUNC);
yyt = yyt->ACF_REDUCTION.REDUCTION_BODY; break;
  case kACF_TASK_REGION:
yyt = yyt->ACF_TASK_REGION.TASK_BODY; break;
  case kACF_PARALLEL:
yyE (yyt->ACF_PARALLEL.REDUCTION_VARS);
yyE (yyt->ACF_PARALLEL.SHARED_VARS);
yyE (yyt->ACF_PARALLEL.LOCAL_VARS);
yyt = yyt->ACF_PARALLEL.PARALLEL_BODY; break;
  case kACF_CRITICAL:
yyt = yyt->ACF_CRITICAL.CRITICAL_BODY; break;
  case kACF_ON:
yyE (yyt->ACF_ON.ON_SPECS);
yyt = yyt->ACF_ON.ON_BODY; break;
  case kACF_RM_READ:
yyE (yyt->ACF_RM_READ.LOCAL_VAR);
yyt = yyt->ACF_RM_READ.REMOTE_VAR; break;
  case kACF_RM_WRITE:
yyE (yyt->ACF_RM_WRITE.REMOTE_VAR);
yyt = yyt->ACF_RM_WRITE.LOCAL_DATA; break;
  case kACF_MOVE:
yyt = yyt->ACF_MOVE.MOVE_STMT; break;
  case kACF_BARRIER:
yyt = yyt->ACF_BARRIER.BARRIER_VARS; break;
  case kACF_UPDATE:
yyt = yyt->ACF_UPDATE.OVERLAP_VAR; break;
  case kON_VAR_CLAUSE:
yyt = yyt->ON_VAR_CLAUSE.ON_VAR; break;
  case kON_PROC_CLAUSE:
yyt = yyt->ON_PROC_CLAUSE.ON_PROC; break;
  case kON_LIST:
yyE (yyt->ON_LIST.Elem);
yyt = yyt->ON_LIST.Next; break;
  case kON_SPEC:
yyt = yyt->ON_SPEC.ON_VAL; break;
  case kSELECTED_ACF_LIST:
yyE (yyt->SELECTED_ACF_LIST.Elem);
yyt = yyt->SELECTED_ACF_LIST.Next; break;
  case kSELECTED_ACF_NODE:
yyE (yyt->SELECTED_ACF_NODE.SELECT_LIST);
yyt = yyt->SELECTED_ACF_NODE.SELECT_ACFS; break;
  case kASSIGN_STMT:
yyE (yyt->ASSIGN_STMT.ASSIGN_VAR);
yyt = yyt->ASSIGN_STMT.ASSIGN_EXP; break;
  case kPTR_ASSIGN_STMT:
yyE (yyt->PTR_ASSIGN_STMT.ASSIGN_VAR);
yyt = yyt->PTR_ASSIGN_STMT.ASSIGN_EXP; break;
  case kLABEL_ASSIGN_STMT:
yyt = yyt->LABEL_ASSIGN_STMT.LABEL_VAR; break;
  case kCALL_STMT:
yyE (yyt->CALL_STMT.CALL_ID);
yyt = yyt->CALL_STMT.CALL_PARAMS; break;
  case kIO_STMT:
yyE (yyt->IO_STMT.ID);
yyE (yyt->IO_STMT.IO_SPECS);
yyt = yyt->IO_STMT.IO_ITEMS; break;
  case kASS_GOTO_STMT:
yyE (yyt->ASS_GOTO_STMT.GOTO_VAR);
return;
  case kCOMP_GOTO_STMT:
yyt = yyt->COMP_GOTO_STMT.GOTO_EXP; break;
  case kCOMP_IF_STMT:
yyt = yyt->COMP_IF_STMT.IF_EXP; break;
  case kRETURN_STMT:
yyt = yyt->RETURN_STMT.RETURN_EXP; break;
  case kSTOP_STMT:
yyt = yyt->STOP_STMT.STOP_CONST; break;
  case kFORMAT_STMT:
yyt = yyt->FORMAT_STMT.FORMAT_PARAMS; break;
  case kINHERIT_DSP_STMT:
yyE (yyt->INHERIT_DSP_STMT.VAR);
yyt = yyt->INHERIT_DSP_STMT.SHAPE; break;
  case kCREATE_DSP_STMT:
yyE (yyt->CREATE_DSP_STMT.VAR);
yyt = yyt->CREATE_DSP_STMT.SHAPE; break;
  case kFREE_DSP_STMT:
yyt = yyt->FREE_DSP_STMT.VAR; break;
  case kALLOCATE_STMT:
yyE (yyt->ALLOCATE_STMT.PARAMS);
yyt = yyt->ALLOCATE_STMT.STATUS; break;
  case kDEALLOCATE_STMT:
yyE (yyt->DEALLOCATE_STMT.PARAMS);
yyt = yyt->DEALLOCATE_STMT.STATUS; break;
  case kNULLIFY_STMT:
yyt = yyt->NULLIFY_STMT.PARAMS; break;
  case kREDUCE_STMT:
yyE (yyt->REDUCE_STMT.RED_FUNC);
yyt = yyt->REDUCE_STMT.RED_PARAMS; break;
  case kMOVE_STMT:
yyE (yyt->MOVE_STMT.TARGET);
yyE (yyt->MOVE_STMT.SOURCE);
yyt = yyt->MOVE_STMT.MASK; break;
  case kSCATTER_STMT:
yyE (yyt->SCATTER_STMT.ARRAY);
yyE (yyt->SCATTER_STMT.BASE);
yyE (yyt->SCATTER_STMT.INDEXES);
yyt = yyt->SCATTER_STMT.MASK; break;
  case kREALIGN_STMT:
yyE (yyt->REALIGN_STMT.ALIGNEE);
yyE (yyt->REALIGN_STMT.ALIGN_SOURCE);
yyt = yyt->REALIGN_STMT.ALIGN_TARGET; break;
  case kREDISTRIBUTE_STMT:
yyE (yyt->REDISTRIBUTE_STMT.DISTRIBUTEE);
yyE (yyt->REDISTRIBUTE_STMT.DISTRIBUTION);
yyt = yyt->REDISTRIBUTE_STMT.TARGET; break;
  case kREG_SHADOW_GET:
yyE (yyt->REG_SHADOW_GET.SHADOW_VAR);
yyt = yyt->REG_SHADOW_GET.SHADOW_SIZE; break;
  case kREG_SHADOW_PUT:
yyE (yyt->REG_SHADOW_PUT.SHADOW_VAR);
yyt = yyt->REG_SHADOW_PUT.SHADOW_SIZE; break;
  case kREG_SHADOW_SET:
yyE (yyt->REG_SHADOW_SET.SHADOW_VAR);
yyE (yyt->REG_SHADOW_SET.SHADOW_SIZE);
yyt = yyt->REG_SHADOW_SET.VAL; break;
  case kIND_SHADOW_CREATE:
yyE (yyt->IND_SHADOW_CREATE.SHADOW_VAR);
yyE (yyt->IND_SHADOW_CREATE.INDEX_VAR);
yyE (yyt->IND_SHADOW_CREATE.TMP_INDEX_VAR);
yyt = yyt->IND_SHADOW_CREATE.MASK; break;
  case kIND_SHADOW_FREE:
yyt = yyt->IND_SHADOW_FREE.INDEX_VAR; break;
  case kIND_SHADOW_GET:
yyt = yyt->IND_SHADOW_GET.SHADOW_VAR; break;
  case kIND_SHADOW_PUT:
yyt = yyt->IND_SHADOW_PUT.SHADOW_VAR; break;
  case kIND_SHADOW_SET:
yyE (yyt->IND_SHADOW_SET.SHADOW_VAR);
yyt = yyt->IND_SHADOW_SET.VAL; break;
  case kBROADCAST_STMT:
yyE (yyt->BROADCAST_STMT.ELEMS);
yyt = yyt->BROADCAST_STMT.OWNER_SPEC; break;
  case kREDUCTION_STMT:
yyE (yyt->REDUCTION_STMT.REDFUNC);
yyE (yyt->REDUCTION_STMT.ELEMS);
yyt = yyt->REDUCTION_STMT.RED_SPEC; break;
  case kDIRTY_STMT:
yyt = yyt->DIRTY_STMT.ELEMS; break;
  case kOP_EXP:
yyE (yyt->OP_EXP.OPND1);
yyt = yyt->OP_EXP.OPND2; break;
  case kOP1_EXP:
yyt = yyt->OP1_EXP.OPND; break;
  case kSLICE_EXP:
yyE (yyt->SLICE_EXP.START);
yyE (yyt->SLICE_EXP.STOP);
yyt = yyt->SLICE_EXP.INC; break;
  case kVAR_EXP:
yyt = yyt->VAR_EXP.V; break;
  case kFUNC_CALL_EXP:
yyE (yyt->FUNC_CALL_EXP.FUNC_ID);
yyt = yyt->FUNC_CALL_EXP.FUNC_PARAMS; break;
  case kNAMED_EXP:
yyt = yyt->NAMED_EXP.VAL; break;
  case kDO_EXP:
yyE (yyt->DO_EXP.DO_ID);
yyE (yyt->DO_EXP.RANGE);
yyt = yyt->DO_EXP.BODY; break;
  case kTYPE_EXP:
yyE (yyt->TYPE_EXP.ID);
yyt = yyt->TYPE_EXP.ELEMENTS; break;
  case kARRAY_EXP:
yyt = yyt->ARRAY_EXP.ELEMENTS; break;
  case kPERM_EXP:
yyt = yyt->PERM_EXP.VAL; break;
  case kBOUND_EXP:
yyt = yyt->BOUND_EXP.VAR; break;
  case kBTE_LIST:
yyE (yyt->BTE_LIST.Elem);
yyt = yyt->BTE_LIST.Next; break;
  case kUSED_VAR:
yyt = yyt->USED_VAR.VARNAME; break;
  case kINDEXED_VAR:
yyE (yyt->INDEXED_VAR.IND_VAR);
yyt = yyt->INDEXED_VAR.IND_EXPS; break;
  case kSUBSTRING_VAR:
yyE (yyt->SUBSTRING_VAR.IND_VAR);
yyt = yyt->SUBSTRING_VAR.IND_EXP; break;
  case kSELECTED_VAR:
yyE (yyt->SELECTED_VAR.SELEC_VAR);
yyt = yyt->SELECTED_VAR.SELECTOR; break;
  case kLOOP_VAR:
yyt = yyt->LOOP_VAR.LOOP_VARNAME; break;
  case kPERM_VAR:
yyt = yyt->PERM_VAR.VAL; break;
  case kADDR:
yyt = yyt->ADDR.E; break;
  case kDO_VAR:
yyE (yyt->DO_VAR.DO_ID);
yyE (yyt->DO_VAR.RANGE);
yyt = yyt->DO_VAR.BODY; break;
  case kREMOTE_VAR:
yyt = yyt->REMOTE_VAR.VAR; break;
  case kBTV_LIST:
yyE (yyt->BTV_LIST.Elem);
yyt = yyt->BTV_LIST.Next; break;
  case kVAR_PARAM:
yyt = yyt->VAR_PARAM.V; break;
  case kVALUE_PARAM:
yyt = yyt->VALUE_PARAM.E; break;
  case kNAMED_PARAM:
yyt = yyt->NAMED_PARAM.VAL; break;
  case kPROC_PARAM:
yyt = yyt->PROC_PARAM.P; break;
  case kFUNC_PARAM:
yyt = yyt->FUNC_PARAM.F; break;
  case kBTP_LIST:
yyE (yyt->BTP_LIST.Elem);
yyt = yyt->BTP_LIST.Next; break;
  default: return;
  }
 }
}

void BeginEval ()
{
}

void CloseEval ()
{
}
