# include "IndShadow.h"
# include "yyIndShadow.w"
# include "System.h"
# include <stdio.h>
# include "Tree.h"
# include "Definitions.h"

# ifndef NULL
# define NULL 0L
# endif
# ifndef false
# define false 0
# endif
# ifndef true
# define true 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) \
  if ((ptr = (tree) free) >= (tree) max) ptr = alloc (); \
  free += nodesize [kind]; \
  ptr->yyHead.yyMark = 0; \
  ptr->Kind = kind;
# else
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) ptr = make (kind);
# endif

# define yyWrite(s) (void) fputs (s, yyf)
# define yyWriteNl (void) fputc ('\n', yyf)

# line 33 "IndShadow.puma"


# include <stdio.h>
# include "Idents.h"
# include "StringMem.h"

# include "protocol.h"

# include "Nesting.h"
# include "ParNest.h"

# include "Transform.h"
# include "Reductions.h"

# include "Types.h"      /* GetTreeType */
# include "Temporary.h"  /* GetVDTemporary */

# define MODULE "IndShadow"

static int schedule_id = 0;



static void yyExit () { Exit (1); }

void (* IndShadow_Exit) () = yyExit;

static FILE * yyf = stdout;

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module IndShadow, routine %s failed\n", yyFunction);
 IndShadow_Exit ();
}

bool IsIndShadowVariable ARGS((tTree var, pvar home));
static bool IndLastIndex ARGS((tTree indexes));
void MakeIndShadowGet ARGS((tTree var, tTree * yyP2, tTree * yyP1));
void MakeIndShadowPut ARGS((tTree var, tTree * yyP4, tTree * yyP3));
void MakeIndShadowReduce ARGS((tTree var, tTree red_fn, tTree * yyP6, tTree * yyP5));
static void GetLastIndexVar ARGS((tTree indexes, tTree * yyP10, tTree * yyP9, tTree * yyP8, tTree * yyP7));

bool IsIndShadowVariable
# if defined __STDC__ | defined __cplusplus
(register tTree var, pvar home)
# else
(var, home)
 register tTree var;
 pvar home;
# endif
{
  if (var->Kind == kINDEXED_VAR) {
# line 67 "IndShadow.puma"
 {
  var_descriptor vard;
  bool okay;
  int i;
  int rank;
  {
# line 69 "IndShadow.puma"

# line 70 "IndShadow.puma"

# line 71 "IndShadow.puma"

# line 72 "IndShadow.puma"

# line 74 "IndShadow.puma"
   if (! ((test_flag))) goto yyL1;
  {
# line 76 "IndShadow.puma"
   SetVarDescriptor (var, & vard);
# line 81 "IndShadow.puma"
 okay = true;

     rank = vard.formal_rank;

     

     for (i=0; i<rank-1; i++)
        if (vard.distribution_kind[i] != kSERIAL_DIM) okay = false;

     

     if (vard.distribution_kind[rank-1] == kSERIAL_DIM) okay = false;

     

   
# line 98 "IndShadow.puma"
   if (! ((okay))) goto yyL1;
  {
# line 102 "IndShadow.puma"
   if (! ((IndLastIndex (var->INDEXED_VAR.IND_EXPS)))) goto yyL1;
  }
  }
  }
   return true;
 }
yyL1:;

  }
  return false;
}

static bool IndLastIndex
# if defined __STDC__ | defined __cplusplus
(register tTree indexes)
# else
(indexes)
 register tTree indexes;
# endif
{
  if (indexes->Kind == kBTE_LIST) {
  if (indexes->BTE_LIST.Elem->Kind == kVAR_EXP) {
  if (indexes->BTE_LIST.Elem->VAR_EXP.V->Kind == kINDEXED_VAR) {
  if (indexes->BTE_LIST.Next->Kind == kBTE_EMPTY) {
# line 107 "IndShadow.puma"
   return true;

  }
  }
  }
# line 110 "IndShadow.puma"
  {
# line 112 "IndShadow.puma"
   if (! ((IndLastIndex (indexes->BTE_LIST.Next)))) goto yyL2;
  }
   return true;
yyL2:;

  }
  return false;
}

void MakeIndShadowGet
# if defined __STDC__ | defined __cplusplus
(register tTree var, register tTree * yyP2, register tTree * yyP1)
# else
(var, yyP2, yyP1)
 register tTree var;
 register tTree * yyP2;
 register tTree * yyP1;
# endif
{
  if (var->Kind == kINDEXED_VAR) {
# line 123 "IndShadow.puma"
 {
  tTree create_stmt;
  tTree get_stmt;
  tTree free_stmt;
  tTree yyV1;
  tTree yyV2;
  tTree yyV3;
  tTree yyV4;
  {
# line 125 "IndShadow.puma"

# line 126 "IndShadow.puma"

# line 127 "IndShadow.puma"

# line 129 "IndShadow.puma"
   GetLastIndexVar (var->INDEXED_VAR.IND_EXPS, & yyV1, & yyV2, & yyV3, & yyV4);
# line 131 "IndShadow.puma"
 schedule_id++;   

     create_stmt = mIND_SHADOW_CREATE (schedule_id,
                                       var->INDEXED_VAR.IND_VAR, yyV1, mDUMMY_VAR (), yyV2);

     create_stmt = mACF_BASIC (create_stmt);

     get_stmt    = mIND_SHADOW_GET (schedule_id, var->INDEXED_VAR.IND_VAR);
     get_stmt    = mACF_BASIC (get_stmt);

     create_stmt = mACF_LIST (create_stmt, mACF_LIST (get_stmt, NoTree));
     create_stmt = CombineACF (yyV3, create_stmt);

     free_stmt   = mIND_SHADOW_FREE (schedule_id, yyV1);

     free_stmt   = mACF_LIST (mACF_BASIC (free_stmt), NoTree);
     free_stmt   = CombineACF (free_stmt, yyV4);
   
  }
   * yyP2 = create_stmt;
   * yyP1 = free_stmt;
   return;
 }

  }
;
}

void MakeIndShadowPut
# if defined __STDC__ | defined __cplusplus
(register tTree var, register tTree * yyP4, register tTree * yyP3)
# else
(var, yyP4, yyP3)
 register tTree var;
 register tTree * yyP4;
 register tTree * yyP3;
# endif
{
  if (var->Kind == kINDEXED_VAR) {
# line 159 "IndShadow.puma"
 {
  tTree create_stmt;
  tTree put_stmt;
  tTree free_stmt;
  tTree yyV1;
  tTree yyV2;
  tTree yyV3;
  tTree yyV4;
  {
# line 161 "IndShadow.puma"

# line 162 "IndShadow.puma"

# line 163 "IndShadow.puma"

# line 165 "IndShadow.puma"
   GetLastIndexVar (var->INDEXED_VAR.IND_EXPS, & yyV1, & yyV2, & yyV3, & yyV4);
# line 167 "IndShadow.puma"
 schedule_id++;   

     create_stmt = mIND_SHADOW_CREATE (schedule_id,
                                       var->INDEXED_VAR.IND_VAR, yyV1, mDUMMY_VAR (), yyV2);

     create_stmt = mACF_BASIC (create_stmt);
     create_stmt = mACF_LIST (create_stmt, NoTree);
     create_stmt = CombineACF (yyV3, create_stmt);

     put_stmt    = mIND_SHADOW_PUT (schedule_id, 0, var->INDEXED_VAR.IND_VAR);
     put_stmt    = mACF_BASIC (put_stmt);

     free_stmt   = mIND_SHADOW_FREE (schedule_id, yyV1);

     free_stmt   = mACF_LIST (mACF_BASIC (free_stmt), NoTree);
     free_stmt   = CombineACF (put_stmt, free_stmt);
     free_stmt   = CombineACF (free_stmt, yyV4);
   
  }
   * yyP4 = create_stmt;
   * yyP3 = free_stmt;
   return;
 }

  }
;
}

void MakeIndShadowReduce
# if defined __STDC__ | defined __cplusplus
(register tTree var, register tTree red_fn, register tTree * yyP6, register tTree * yyP5)
# else
(var, red_fn, yyP6, yyP5)
 register tTree var;
 register tTree red_fn;
 register tTree * yyP6;
 register tTree * yyP5;
# endif
{
  if (var->Kind == kINDEXED_VAR) {
  if (red_fn->Kind == kPROC_OBJ) {
# line 195 "IndShadow.puma"
 {
  tTree create_stmt;
  tTree set_stmt;
  tTree put_stmt;
  tTree free_stmt;
  int op;
  tTree init_val;
  tTree yyV1;
  tTree yyV2;
  tTree yyV3;
  tTree yyV4;
  {
# line 197 "IndShadow.puma"

# line 198 "IndShadow.puma"

# line 199 "IndShadow.puma"

# line 200 "IndShadow.puma"

# line 201 "IndShadow.puma"

# line 202 "IndShadow.puma"

# line 204 "IndShadow.puma"
   GetLastIndexVar (var->INDEXED_VAR.IND_EXPS, & yyV1, & yyV2, & yyV3, & yyV4);
# line 206 "IndShadow.puma"
 schedule_id++;   

     create_stmt = mIND_SHADOW_CREATE (schedule_id, var->INDEXED_VAR.IND_VAR, 
                                       yyV1, mDUMMY_VAR (), yyV2);

     create_stmt = mACF_BASIC (create_stmt);

     init_val    = GetReductionZero (TreeType (var), red_fn->PROC_OBJ.Ident);
     set_stmt    = mIND_SHADOW_SET (schedule_id, var->INDEXED_VAR.IND_VAR, mCONST_EXP (init_val));
     set_stmt    = mACF_BASIC (set_stmt);

     op          = GetGlobalOp (TreeType(var), red_fn->PROC_OBJ.Ident);
     put_stmt    = mIND_SHADOW_PUT (schedule_id, op, var->INDEXED_VAR.IND_VAR);
     put_stmt    = mACF_BASIC (put_stmt);

     create_stmt = mACF_LIST (create_stmt, mACF_LIST (set_stmt, NoTree));
     create_stmt = CombineACF (yyV3, create_stmt);

     free_stmt   = mIND_SHADOW_FREE (schedule_id, yyV1);
     free_stmt   = mACF_BASIC (free_stmt);

     free_stmt   = mACF_LIST (put_stmt, mACF_LIST (free_stmt, NoTree));
     free_stmt   = CombineACF (free_stmt, yyV4);
   
  }
   * yyP6 = create_stmt;
   * yyP5 = free_stmt;
   return;
 }

  }
  }
# line 232 "IndShadow.puma"
  {
# line 234 "IndShadow.puma"
   failure_protocol (MODULE, "MakeIndShadowReduce", var);
  }
   * yyP6 = NoTree;
   * yyP5 = NoTree;
   return;

;
}

static void GetLastIndexVar
# if defined __STDC__ | defined __cplusplus
(register tTree indexes, register tTree * yyP10, register tTree * yyP9, register tTree * yyP8, register tTree * yyP7)
# else
(indexes, yyP10, yyP9, yyP8, yyP7)
 register tTree indexes;
 register tTree * yyP10;
 register tTree * yyP9;
 register tTree * yyP8;
 register tTree * yyP7;
# endif
{
  if (indexes->Kind == kBTE_LIST) {
  if (indexes->BTE_LIST.Elem->Kind == kVAR_EXP) {
  if (indexes->BTE_LIST.Elem->VAR_EXP.V->Kind == kINDEXED_VAR) {
  if (indexes->BTE_LIST.Next->Kind == kBTE_EMPTY) {
# line 245 "IndShadow.puma"
 {
  tTree pre;
  tTree post;
  tTree tmp;
  tTree var;
  var_descriptor vard;
  {
# line 248 "IndShadow.puma"

# line 249 "IndShadow.puma"

# line 250 "IndShadow.puma"

# line 251 "IndShadow.puma"

# line 253 "IndShadow.puma"

# line 255 "IndShadow.puma"
   SetVarDescriptor (indexes->BTE_LIST.Elem->VAR_EXP.V, & vard);
# line 256 "IndShadow.puma"
   FullExpansion (& vard);
# line 258 "IndShadow.puma"
 tmp = GetVDTemporary (&vard);
     var = indexes->BTE_LIST.Elem->VAR_EXP.V->INDEXED_VAR.IND_VAR;

     if (tmp == NoTree)

        { error_protocol ("could not create temporary");
          pre  = NoTree;
          post = NoTree;
        }

      else

        { GetMemoryStmts (&pre, &post);
          pre = CombineACF (pre, NoTree);
          post = CombineACF (post, NoTree);
        }

      indexes->BTE_LIST.Elem->VAR_EXP.V = CopyTree (tmp);
   
  }
   * yyP10 = var;
   * yyP9 = tmp;
   * yyP8 = pre;
   * yyP7 = post;
   return;
 }

  }
  }
  }
# line 279 "IndShadow.puma"
 {
  tTree yyV1;
  tTree yyV2;
  tTree yyV3;
  tTree yyV4;
  {
# line 281 "IndShadow.puma"
   GetLastIndexVar (indexes->BTE_LIST.Next, & yyV1, & yyV2, & yyV3, & yyV4);
  }
   * yyP10 = yyV1;
   * yyP9 = yyV2;
   * yyP8 = yyV3;
   * yyP7 = yyV4;
   return;
 }

  }
# line 284 "IndShadow.puma"
  {
# line 286 "IndShadow.puma"
   failure_protocol (MODULE, "GetLastIndexVar", indexes);
  }
   * yyP10 = NoTree;
   * yyP9 = NoTree;
   * yyP8 = NoTree;
   * yyP7 = NoTree;
   return;

;
}

void BeginIndShadow ()
{
}

void CloseIndShadow ()
{
}
