# include "NewStatements.h"
# include "yyNewStatements.w"
# include "System.h"
# include <stdio.h>
# include "Tree.h"
# include "Definitions.h"

# ifndef NULL
# define NULL 0L
# endif
# ifndef false
# define false 0
# endif
# ifndef true
# define true 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) \
  if ((ptr = (tree) free) >= (tree) max) ptr = alloc (); \
  free += nodesize [kind]; \
  ptr->yyHead.yyMark = 0; \
  ptr->Kind = kind;
# else
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) ptr = make (kind);
# endif

# define yyWrite(s) (void) fputs (s, yyf)
# define yyWriteNl (void) fputc ('\n', yyf)

# line 21 "NewStatements.puma"


# undef DEBUG

# include <stdio.h>
# include "Idents.h"
# include "StringMem.h"

# include "protocol.h"

# include "Types.h"
# include "Transform.h"    /* ReplaceACF, ... */
# include "Expressions.h"  /* MakeNotExp, ... */

# include "TreeOps.h"      /* IsVarInExp      */
# include "Loops.h"        /* IsParallelLoop  */
# include "Rank.h"         /* TreeRank        */

# include "Nesting.h"

# define MODULE "NewStatements"

static tTree par_info = NoTree;   /* reuse one Tree for many purposes */



static void yyExit () { Exit (1); }

void (* NewStatements_Exit) () = yyExit;

static FILE * yyf = stdout;

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module NewStatements, routine %s failed\n", yyFunction);
 NewStatements_Exit ();
}

void ExpandNewStatements ARGS((tTree t, tTree loop, int line));
void MaskNewStatements ARGS((tTree t, tTree mask, bool true_flag, int line));
static tTree MakeOuterLoop ARGS((tTree loop, tTree body));
static tTree CopyInfo ARGS((tTree info));
static void GetExpansionInfo ARGS((tTree loop, int * yyP5, tTree * yyP4, tTree * yyP3, tTree * yyP2, tTree * yyP1));
static bool IsBodyInvariant ARGS((tTree body, tTree loopvar));
static tTree MakeOuterMask ARGS((tTree mask, bool true_flag, tTree body));

void ExpandNewStatements
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tTree loop, register int line)
# else
(t, loop, line)
 register tTree t;
 register tTree loop;
 register int line;
# endif
{
# line 80 "NewStatements.puma"
  {
# line 81 "NewStatements.puma"
   if (! ((t == NoTree))) goto yyL1;
  }
   return;
yyL1:;

  if (t->Kind == kACF_LIST) {
  if (t->ACF_LIST.Elem->Kind == kACF_BASIC) {

  switch (t->ACF_LIST.Elem->ACF_BASIC.BASIC_STMT->Kind) {
  case kALLOCATE_STMT:
# line 84 "NewStatements.puma"
  {
# line 88 "NewStatements.puma"
   ExpandNewStatements (t->ACF_LIST.Next, loop, line);
  }
   return;

  case kDEALLOCATE_STMT:
# line 91 "NewStatements.puma"
  {
# line 95 "NewStatements.puma"
   ExpandNewStatements (t->ACF_LIST.Next, loop, line);
  }
   return;

  case kCREATE_DSP_STMT:
# line 98 "NewStatements.puma"
  {
# line 100 "NewStatements.puma"
   ExpandNewStatements (t->ACF_LIST.Next, loop, line);
  }
   return;

  case kFREE_DSP_STMT:
# line 103 "NewStatements.puma"
  {
# line 105 "NewStatements.puma"
   ExpandNewStatements (t->ACF_LIST.Next, loop, line);
  }
   return;

  case kIND_SHADOW_CREATE:
# line 108 "NewStatements.puma"
  {
# line 110 "NewStatements.puma"
   ExpandNewStatements (t->ACF_LIST.Next, loop, line);
  }
   return;

  case kIND_SHADOW_FREE:
# line 113 "NewStatements.puma"
  {
# line 115 "NewStatements.puma"
   ExpandNewStatements (t->ACF_LIST.Next, loop, line);
  }
   return;

  case kIND_SHADOW_GET:
# line 118 "NewStatements.puma"
  {
# line 120 "NewStatements.puma"
   ExpandNewStatements (t->ACF_LIST.Next, loop, line);
  }
   return;

  case kIND_SHADOW_SET:
# line 123 "NewStatements.puma"
  {
# line 125 "NewStatements.puma"
   ExpandNewStatements (t->ACF_LIST.Next, loop, line);
  }
   return;

  case kIND_SHADOW_PUT:
# line 128 "NewStatements.puma"
  {
# line 130 "NewStatements.puma"
   ExpandNewStatements (t->ACF_LIST.Next, loop, line);
  }
   return;

  case kASSIGN_STMT:
# line 133 "NewStatements.puma"
  {
# line 135 "NewStatements.puma"
   t->ACF_LIST.Elem->ACF_BASIC.Line = line;
# line 136 "NewStatements.puma"
  t->ACF_LIST.Elem = MakeOuterLoop (loop, t->ACF_LIST.Elem); 
# line 138 "NewStatements.puma"
   ExpandNewStatements (t->ACF_LIST.Next, loop, line);
  }
   return;

  case kREDUCE_STMT:
# line 141 "NewStatements.puma"
  {
# line 143 "NewStatements.puma"
   t->ACF_LIST.Elem->ACF_BASIC.Line = line;
# line 144 "NewStatements.puma"
  t->ACF_LIST.Elem = MakeOuterLoop (loop, t->ACF_LIST.Elem); 
# line 146 "NewStatements.puma"
   ExpandNewStatements (t->ACF_LIST.Next, loop, line);
  }
   return;

  }

  }
  if (t->ACF_LIST.Elem->Kind == kACF_FORALL) {
# line 149 "NewStatements.puma"
  {
# line 151 "NewStatements.puma"
   t->ACF_LIST.Elem->ACF_FORALL.Line = line;
# line 153 "NewStatements.puma"
  t->ACF_LIST.Elem = MakeOuterLoop (loop, t->ACF_LIST.Elem); 
# line 155 "NewStatements.puma"
   ExpandNewStatements (t->ACF_LIST.Next, loop, line);
  }
   return;

  }
  if (t->ACF_LIST.Elem->Kind == kACF_HOME) {
# line 158 "NewStatements.puma"
  {
# line 160 "NewStatements.puma"
   ExpandNewStatements (t->ACF_LIST.Next, t->ACF_LIST.Elem->ACF_HOME.HOME_BODY, line);
  }
   return;

  }
  if (t->ACF_LIST.Elem->Kind == kACF_DO) {
# line 163 "NewStatements.puma"
  {
# line 165 "NewStatements.puma"
   t->ACF_LIST.Elem->ACF_DO.Line = line;
# line 166 "NewStatements.puma"
  t->ACF_LIST.Elem = MakeOuterLoop (loop, t->ACF_LIST.Elem); 
# line 168 "NewStatements.puma"
   ExpandNewStatements (t->ACF_LIST.Next, loop, line);
  }
   return;

  }
  if (t->ACF_LIST.Elem->Kind == kACF_IF) {
# line 171 "NewStatements.puma"
  {
# line 173 "NewStatements.puma"
   t->ACF_LIST.Elem->ACF_IF.Line = line;
# line 174 "NewStatements.puma"
  t->ACF_LIST.Elem = MakeOuterLoop (loop, t->ACF_LIST.Elem); 
# line 176 "NewStatements.puma"
   ExpandNewStatements (t->ACF_LIST.Next, loop, line);
  }
   return;

  }
  }
  if (t->Kind == kACF_EMPTY) {
# line 179 "NewStatements.puma"
   return;

  }
# line 182 "NewStatements.puma"
  {
# line 183 "NewStatements.puma"
   failure_protocol (MODULE, "ExpandNewStatements", t);
  }
   return;

;
}

void MaskNewStatements
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tTree mask, register bool true_flag, register int line)
# else
(t, mask, true_flag, line)
 register tTree t;
 register tTree mask;
 register bool true_flag;
 register int line;
# endif
{
# line 195 "NewStatements.puma"
  {
# line 196 "NewStatements.puma"
   if (! ((t == NoTree))) goto yyL1;
  }
   return;
yyL1:;

  if (t->Kind == kACF_LIST) {
  if (t->ACF_LIST.Elem->Kind == kACF_BASIC) {
  if (t->ACF_LIST.Elem->ACF_BASIC.BASIC_STMT->Kind == kALLOCATE_STMT) {
# line 199 "NewStatements.puma"
  {
# line 203 "NewStatements.puma"
   MaskNewStatements (t->ACF_LIST.Next, mask, true_flag, line);
  }
   return;

  }
  if (t->ACF_LIST.Elem->ACF_BASIC.BASIC_STMT->Kind == kDEALLOCATE_STMT) {
# line 206 "NewStatements.puma"
  {
# line 210 "NewStatements.puma"
   MaskNewStatements (t->ACF_LIST.Next, mask, true_flag, line);
  }
   return;

  }
  if (t->ACF_LIST.Elem->ACF_BASIC.BASIC_STMT->Kind == kCREATE_DSP_STMT) {
# line 213 "NewStatements.puma"
  {
# line 215 "NewStatements.puma"
   MaskNewStatements (t->ACF_LIST.Next, mask, true_flag, line);
  }
   return;

  }
  if (t->ACF_LIST.Elem->ACF_BASIC.BASIC_STMT->Kind == kFREE_DSP_STMT) {
# line 218 "NewStatements.puma"
  {
# line 220 "NewStatements.puma"
   MaskNewStatements (t->ACF_LIST.Next, mask, true_flag, line);
  }
   return;

  }
  if (t->ACF_LIST.Elem->ACF_BASIC.BASIC_STMT->Kind == kASSIGN_STMT) {
# line 223 "NewStatements.puma"
  {
# line 225 "NewStatements.puma"
   t->ACF_LIST.Elem->ACF_BASIC.Line = line;
# line 226 "NewStatements.puma"
  t->ACF_LIST.Elem = MakeOuterMask (mask, true_flag, t->ACF_LIST.Elem); 
# line 228 "NewStatements.puma"
   MaskNewStatements (t->ACF_LIST.Next, mask, true_flag, line);
  }
   return;

  }
  if (t->ACF_LIST.Elem->ACF_BASIC.BASIC_STMT->Kind == kREDUCE_STMT) {
# line 231 "NewStatements.puma"
  {
# line 233 "NewStatements.puma"
   t->ACF_LIST.Elem->ACF_BASIC.Line = line;
# line 234 "NewStatements.puma"
  t->ACF_LIST.Elem = MakeOuterMask (mask, true_flag, t->ACF_LIST.Elem); 
# line 236 "NewStatements.puma"
   MaskNewStatements (t->ACF_LIST.Next, mask, true_flag, line);
  }
   return;

  }
  }
  if (t->ACF_LIST.Elem->Kind == kACF_FORALL) {
# line 239 "NewStatements.puma"
  {
# line 241 "NewStatements.puma"
   t->ACF_LIST.Elem->ACF_FORALL.Line = line;
# line 242 "NewStatements.puma"
  t->ACF_LIST.Elem = MakeOuterMask (mask, true_flag, t->ACF_LIST.Elem); 
# line 244 "NewStatements.puma"
   MaskNewStatements (t->ACF_LIST.Next, mask, true_flag, line);
  }
   return;

  }
  if (t->ACF_LIST.Elem->Kind == kACF_DO) {
# line 247 "NewStatements.puma"
  {
# line 249 "NewStatements.puma"
   if (! ((IsParallelLoop (t->ACF_LIST.Elem)))) goto yyL9;
  {
# line 251 "NewStatements.puma"
   t->ACF_LIST.Elem->ACF_DO.Line = line;
# line 252 "NewStatements.puma"
  t->ACF_LIST.Elem = MakeOuterMask (mask, true_flag, t->ACF_LIST.Elem); 
# line 254 "NewStatements.puma"
   MaskNewStatements (t->ACF_LIST.Next, mask, true_flag, line);
  }
  }
   return;
yyL9:;

  }
  if (t->ACF_LIST.Elem->Kind == kACF_IF) {
# line 257 "NewStatements.puma"
  {
# line 259 "NewStatements.puma"
   t->ACF_LIST.Elem->ACF_IF.Line = line;
# line 260 "NewStatements.puma"
  t->ACF_LIST.Elem = MakeOuterMask (mask, true_flag, t->ACF_LIST.Elem); 
# line 262 "NewStatements.puma"
   MaskNewStatements (t->ACF_LIST.Next, mask, true_flag, line);
  }
   return;

  }
  if (t->ACF_LIST.Elem->Kind == kACF_WHERE) {
# line 265 "NewStatements.puma"
  {
# line 267 "NewStatements.puma"
   t->ACF_LIST.Elem->ACF_WHERE.Line = line;
# line 269 "NewStatements.puma"
  t->ACF_LIST.Elem = MakeOuterMask (mask, true_flag, t->ACF_LIST.Elem); 
# line 271 "NewStatements.puma"
   MaskNewStatements (t->ACF_LIST.Next, mask, true_flag, line);
  }
   return;

  }
  }
  if (t->Kind == kACF_EMPTY) {
# line 274 "NewStatements.puma"
   return;

  }
# line 277 "NewStatements.puma"
  {
# line 278 "NewStatements.puma"
   failure_protocol (MODULE, "MaskNewStatements", t);
  }
   return;

;
}

static tTree MakeOuterLoop
# if defined __STDC__ | defined __cplusplus
(register tTree loop, register tTree body)
# else
(loop, body)
 register tTree loop;
 register tTree body;
# endif
{
# line 304 "NewStatements.puma"
 {
  int yyV1;
  tTree yyV2;
  tTree yyV3;
  tTree yyV4;
  tTree yyV5;
  {
# line 306 "NewStatements.puma"
   GetExpansionInfo (loop, & yyV1, & yyV2, & yyV3, & yyV4, & yyV5);
# line 308 "NewStatements.puma"
   if (! ((yyV3 != NoTree))) goto yyL1;
  {
# line 310 "NewStatements.puma"
   if (! ((IsBodyInvariant (body, yyV2)))) goto yyL1;
  }
  }
  {
   return body;
  }
 }
yyL1:;

# line 315 "NewStatements.puma"
 {
  int yyV1;
  tTree yyV2;
  tTree yyV3;
  tTree yyV4;
  tTree yyV5;
  tTree new;
  tTree dep_info1;
  tTree home_info1;
  {
# line 317 "NewStatements.puma"
   GetExpansionInfo (loop, & yyV1, & yyV2, & yyV3, & yyV4, & yyV5);
# line 319 "NewStatements.puma"
   if (! ((yyV3 != NoTree))) goto yyL2;
  {
# line 321 "NewStatements.puma"

# line 322 "NewStatements.puma"

# line 323 "NewStatements.puma"

# line 325 "NewStatements.puma"
 new = mACF_LIST (body, mACF_EMPTY ());

     if (yyV4 == NoTree)
         dep_info1  = mINDEP_INFO (false, 0, NoTree, NoTree);
      else
         dep_info1 = CopyInfo (yyV4);

     if (yyV5 == NoTree)
         home_info1  = mNO_HOME_INFO ();
      else
         home_info1 = CopyInfo (yyV5);

     new = mACF_FORALL (CopyTree(yyV2), CopyTree(yyV3), new, 
                        dep_info1, home_info1);

     new->ACF_NODE.Line = yyV1;
     new->ACF_NODE.Label = 0;    
   
  }
  }
  {
   return new;
  }
 }
yyL2:;

# line 347 "NewStatements.puma"
  {
# line 349 "NewStatements.puma"
   failure_protocol (MODULE, "MakeOuterLoop", loop);
  }
   return NoTree;

}

static tTree CopyInfo
# if defined __STDC__ | defined __cplusplus
(register tTree info)
# else
(info)
 register tTree info;
# endif
{
  if (info->Kind == kINDEP_INFO) {
# line 370 "NewStatements.puma"
   return mINDEP_INFO (info->INDEP_INFO.user_independent, info->INDEP_INFO.selection, NoTree, NoTree);

  }
  if (info->Kind == kSERIAL_INFO) {
# line 375 "NewStatements.puma"
   return mSERIAL_INFO ();

  }
  if (info->Kind == kNO_HOME_INFO) {
# line 380 "NewStatements.puma"
   return mNO_HOME_INFO ();

  }
  if (info->Kind == kCOMM_INFO) {
# line 385 "NewStatements.puma"
   return mCOMM_INFO (CopyTree (info->COMM_INFO.home_var), info->COMM_INFO.is_local);

  }
# line 390 "NewStatements.puma"
  {
# line 392 "NewStatements.puma"
   failure_protocol (MODULE, "CopyInfo", info);
  }
   return NoTree;

}

static void GetExpansionInfo
# if defined __STDC__ | defined __cplusplus
(register tTree loop, register int * yyP5, register tTree * yyP4, register tTree * yyP3, register tTree * yyP2, register tTree * yyP1)
# else
(loop, yyP5, yyP4, yyP3, yyP2, yyP1)
 register tTree loop;
 register int * yyP5;
 register tTree * yyP4;
 register tTree * yyP3;
 register tTree * yyP2;
 register tTree * yyP1;
# endif
{
  if (loop->Kind == kACF_FORALL) {
# line 404 "NewStatements.puma"
   * yyP5 = loop->ACF_FORALL.Line;
   * yyP4 = loop->ACF_FORALL.FORALL_ID;
   * yyP3 = loop->ACF_FORALL.FORALL_RANGE;
   * yyP2 = loop->ACF_FORALL.FORALL_DEP_INFO;
   * yyP1 = loop->ACF_FORALL.FORALL_HOME_INFO;
   return;

  }
  if (loop->Kind == kACF_DO) {
# line 409 "NewStatements.puma"
   * yyP5 = loop->ACF_DO.Line;
   * yyP4 = loop->ACF_DO.DO_ID;
   * yyP3 = loop->ACF_DO.DO_RANGE;
   * yyP2 = loop->ACF_DO.DO_DEP_INFO;
   * yyP1 = loop->ACF_DO.DO_HOME_INFO;
   return;

  }
  if (loop->Kind == kDO_EXP) {
# line 414 "NewStatements.puma"
   * yyP5 = 0;
   * yyP4 = loop->DO_EXP.DO_ID;
   * yyP3 = loop->DO_EXP.RANGE;
   * yyP2 = NoTree;
   * yyP1 = NoTree;
   return;

  }
  if (loop->Kind == kDO_VAR) {
# line 417 "NewStatements.puma"
   * yyP5 = 0;
   * yyP4 = loop->DO_VAR.DO_ID;
   * yyP3 = loop->DO_VAR.RANGE;
   * yyP2 = NoTree;
   * yyP1 = NoTree;
   return;

  }
# line 420 "NewStatements.puma"
   * yyP5 = 0;
   * yyP4 = NoTree;
   * yyP3 = NoTree;
   * yyP2 = NoTree;
   * yyP1 = NoTree;
   return;

;
}

static bool IsBodyInvariant
# if defined __STDC__ | defined __cplusplus
(register tTree body, register tTree loopvar)
# else
(body, loopvar)
 register tTree body;
 register tTree loopvar;
# endif
{
  if (body->Kind == kACF_LIST) {
  if (body->ACF_LIST.Next->Kind == kACF_EMPTY) {
# line 425 "NewStatements.puma"
  {
# line 427 "NewStatements.puma"
   if (! ((IsBodyInvariant (body->ACF_LIST.Elem, loopvar)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  }
  if (body->Kind == kACF_FORALL) {
# line 430 "NewStatements.puma"
  {
# line 432 "NewStatements.puma"
   if (! ((IsBodyInvariant (body->ACF_FORALL.FORALL_BODY, loopvar)))) goto yyL2;
  }
   return true;
yyL2:;

  }
  if (body->Kind == kACF_BASIC) {
  if (body->ACF_BASIC.BASIC_STMT->Kind == kASSIGN_STMT) {
  if (loopvar->Kind == kLOOP_VAR) {
# line 435 "NewStatements.puma"
 {
  bool invariant;
  {
# line 437 "NewStatements.puma"

# line 439 "NewStatements.puma"
 invariant = (IsVarInExp (TreeVarName (loopvar), body->ACF_BASIC.BASIC_STMT->ASSIGN_STMT.ASSIGN_VAR) == 0);

     if (invariant)
 
        { 
          
          invariant = (IsVarInExp (TreeVarName (loopvar), body->ACF_BASIC.BASIC_STMT->ASSIGN_STMT.ASSIGN_EXP) == 0);
 
          if (!invariant)

           { error_protocol ("temporary not sufficient");
             tree_protocol ("invariant lhs : ", body->ACF_BASIC.BASIC_STMT->ASSIGN_STMT.ASSIGN_VAR);
             tree_protocol ("non invariant rhs : ", body->ACF_BASIC.BASIC_STMT->ASSIGN_STMT.ASSIGN_EXP);
             tree_protocol ("missing loop var : ", loopvar);
           }
        }

   
# line 458 "NewStatements.puma"
   if (! ((invariant))) goto yyL3;
  }
   return true;
 }
yyL3:;

  }
# line 461 "NewStatements.puma"
  {
# line 462 "NewStatements.puma"
   return false;
  }

  }
  }
  return false;
}

static tTree MakeOuterMask
# if defined __STDC__ | defined __cplusplus
(register tTree mask, register bool true_flag, register tTree body)
# else
(mask, true_flag, body)
 register tTree mask;
 register bool true_flag;
 register tTree body;
# endif
{
# line 479 "NewStatements.puma"
 {
  tTree new;
  {
# line 481 "NewStatements.puma"
   if (! ((true_flag))) goto yyL1;
  {
# line 483 "NewStatements.puma"

# line 485 "NewStatements.puma"
 new = mACF_LIST (body, mACF_EMPTY ());
     if (TreeRank (mask) == 0)
        new = mACF_IF (CopyTree (mask), new, mACF_EMPTY ());
      else
        new = mACF_WHERE (CopyTree (mask), new, mACF_EMPTY ());
   
  }
  }
  {
   return new;
  }
 }
yyL1:;

# line 494 "NewStatements.puma"
 {
  tTree new;
  {
# line 496 "NewStatements.puma"

# line 498 "NewStatements.puma"
 new = mACF_LIST (body, mACF_EMPTY ());
     if (TreeRank (mask) == 0)
        new = mACF_IF (MakeNotExp (CopyTree (mask)), new, mACF_EMPTY ());
      else
        new = mACF_WHERE (MakeNotExp (CopyTree (mask)), new, mACF_EMPTY ());
   
  }
  {
   return new;
  }
 }

}

void BeginNewStatements ()
{
}

void CloseNewStatements ()
{
}
