# include "Tree.inc"

tTree mCOMP_UNIT
# if defined __STDC__ | defined __cplusplus
(tTree pCOMP_ELEMENTS, tTree pUSED_ELEMENTS)
# else
(pCOMP_ELEMENTS, pUSED_ELEMENTS)
tTree pCOMP_ELEMENTS;
tTree pUSED_ELEMENTS;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kCOMP_UNIT])
 yyt->Kind = kCOMP_UNIT;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 yyt->COMP_UNIT.COMP_ELEMENTS = pCOMP_ELEMENTS;
 yyt->COMP_UNIT.USED_ELEMENTS = pUSED_ELEMENTS;
 return yyt;
}

tTree mUNIT_NODE_LIST
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kUNIT_NODE_LIST])
 yyt->Kind = kUNIT_NODE_LIST;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 return yyt;
}

tTree mUNIT_EMPTY
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kUNIT_EMPTY])
 yyt->Kind = kUNIT_EMPTY;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 return yyt;
}

tTree mUNIT_LIST
# if defined __STDC__ | defined __cplusplus
(tTree pElem, tTree pNext)
# else
(pElem, pNext)
tTree pElem;
tTree pNext;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kUNIT_LIST])
 yyt->Kind = kUNIT_LIST;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 yyt->UNIT_LIST.Elem = pElem;
 yyt->UNIT_LIST.Next = pNext;
 return yyt;
}

tTree mUNIT_NODE
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, int pLine)
# else
(pIdent, pLine)
tIdent pIdent;
int pLine;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kUNIT_NODE])
 yyt->Kind = kUNIT_NODE;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 yyt->UNIT_NODE.Ident = pIdent;
 yyt->UNIT_NODE.Line = pLine;
 begintDefinitions(yyt->UNIT_NODE.Object)
 return yyt;
}

tTree mMODULE_DECL
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, int pLine, tTree pMODULE_BODY)
# else
(pIdent, pLine, pMODULE_BODY)
tIdent pIdent;
int pLine;
tTree pMODULE_BODY;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kMODULE_DECL])
 yyt->Kind = kMODULE_DECL;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 yyt->MODULE_DECL.Ident = pIdent;
 yyt->MODULE_DECL.Line = pLine;
 begintDefinitions(yyt->MODULE_DECL.Object)
 yyt->MODULE_DECL.MODULE_BODY = pMODULE_BODY;
 return yyt;
}

tTree mPROGRAM_DECL
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, int pLine, tTree pFORMALS, tTree pPROGRAM_BODY)
# else
(pIdent, pLine, pFORMALS, pPROGRAM_BODY)
tIdent pIdent;
int pLine;
tTree pFORMALS;
tTree pPROGRAM_BODY;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kPROGRAM_DECL])
 yyt->Kind = kPROGRAM_DECL;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 yyt->PROGRAM_DECL.Ident = pIdent;
 yyt->PROGRAM_DECL.Line = pLine;
 begintDefinitions(yyt->PROGRAM_DECL.Object)
 yyt->PROGRAM_DECL.FORMALS = pFORMALS;
 yyt->PROGRAM_DECL.PROGRAM_BODY = pPROGRAM_BODY;
 return yyt;
}

tTree mPROC_DECL
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, int pLine, tTree pFORMALS, tTree pPROC_BODY)
# else
(pIdent, pLine, pFORMALS, pPROC_BODY)
tIdent pIdent;
int pLine;
tTree pFORMALS;
tTree pPROC_BODY;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kPROC_DECL])
 yyt->Kind = kPROC_DECL;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 yyt->PROC_DECL.Ident = pIdent;
 yyt->PROC_DECL.Line = pLine;
 begintDefinitions(yyt->PROC_DECL.Object)
 yyt->PROC_DECL.FORMALS = pFORMALS;
 yyt->PROC_DECL.PROC_BODY = pPROC_BODY;
 beginbool(yyt->PROC_DECL.IsRecursive)
 beginbool(yyt->PROC_DECL.IsPure)
 begintIdent(yyt->PROC_DECL.HPFExtrinsic)
 return yyt;
}

tTree mFUNC_DECL
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, int pLine, tTree pFORMALS, tTree pFUNC_BODY, tTree pRESULT_TYPE, tIdent pRESULT_ID)
# else
(pIdent, pLine, pFORMALS, pFUNC_BODY, pRESULT_TYPE, pRESULT_ID)
tIdent pIdent;
int pLine;
tTree pFORMALS;
tTree pFUNC_BODY;
tTree pRESULT_TYPE;
tIdent pRESULT_ID;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kFUNC_DECL])
 yyt->Kind = kFUNC_DECL;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 yyt->FUNC_DECL.Ident = pIdent;
 yyt->FUNC_DECL.Line = pLine;
 begintDefinitions(yyt->FUNC_DECL.Object)
 yyt->FUNC_DECL.FORMALS = pFORMALS;
 yyt->FUNC_DECL.FUNC_BODY = pFUNC_BODY;
 yyt->FUNC_DECL.RESULT_TYPE = pRESULT_TYPE;
 yyt->FUNC_DECL.RESULT_ID = pRESULT_ID;
 beginbool(yyt->FUNC_DECL.IsRecursive)
 beginbool(yyt->FUNC_DECL.IsPure)
 begintIdent(yyt->FUNC_DECL.HPFExtrinsic)
 return yyt;
}

tTree mMODULE_PROC_DECL
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, int pLine)
# else
(pIdent, pLine)
tIdent pIdent;
int pLine;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kMODULE_PROC_DECL])
 yyt->Kind = kMODULE_PROC_DECL;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 yyt->MODULE_PROC_DECL.Ident = pIdent;
 yyt->MODULE_PROC_DECL.Line = pLine;
 begintDefinitions(yyt->MODULE_PROC_DECL.Object)
 return yyt;
}

tTree mBLOCK_DATA_DECL
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, int pLine, tTree pDATA_BODY)
# else
(pIdent, pLine, pDATA_BODY)
tIdent pIdent;
int pLine;
tTree pDATA_BODY;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kBLOCK_DATA_DECL])
 yyt->Kind = kBLOCK_DATA_DECL;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 yyt->BLOCK_DATA_DECL.Ident = pIdent;
 yyt->BLOCK_DATA_DECL.Line = pLine;
 begintDefinitions(yyt->BLOCK_DATA_DECL.Object)
 yyt->BLOCK_DATA_DECL.DATA_BODY = pDATA_BODY;
 return yyt;
}

