# ifndef yyCodeGeneral
# define yyCodeGeneral

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifndef bool
# define bool char
# endif

# include "Tree.h"
# include "Definitions.h"

# line 38 "CodeGeneral.puma"


extern tTree NewHelpVars;           /* exported to AdaptTransform */

#define COMMON_SUFFIX  "_DDSP"    /* descriptor in common block      */
#define DUMMY_SUFFIX   "_DDSP"    /* descriptor for dummy argument   */
#define LOCAL_SUFFIX   "_DSP"     /* local descriptor                */
#define DYNAMIC_SUFFIX "_NDSP"    /* temporary descriptor for redist */



extern void (* CodeGeneral_Exit) ();

extern tTree FirstArrayElement ARGS((tTree t));
extern void DefineNewIntVar ARGS((tIdent name));
extern void DefineNewHelpFn ARGS((tIdent name));
extern void DefineNewCommonVar ARGS((tIdent cname, tIdent vname));
extern void DefineNewAddrVar ARGS((tIdent name));
extern tTree MakeDistributeParams ARGS((tDefinitions ilist));
extern tTree MakeTopologyParam ARGS((tDefinitions top_obj));
extern tTree MakeTreeSizeParam ARGS((tTree t));
extern tTree MakeRemoteParams ARGS((tTree var));
extern tTree MakeExtensionParams ARGS((tTree t));
extern tTree MakeSectionParams ARGS((tTree indexes));

extern void BeginCodeGeneral ();
extern void CloseCodeGeneral ();

# endif
