# ifndef yyMoveDescriptor
# define yyMoveDescriptor

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifndef bool
# define bool char
# endif

# include "Tree.h"
# include "Definitions.h"

# line 47 "MoveDescriptor.puma"


typedef struct

   { int    shift_rank;
     int    shift_pos  [MAX_DIMENSIONS];

   } shift_vector;

typedef shift_vector *pshift;

# include "VarDescriptor.h"



extern void (* MoveDescriptor_Exit) ();

extern void PrintShifting ARGS((pshift s));
extern bool IsZeroShifting ARGS((pshift shift));
extern bool VDIsShifting ARGS((pvar d1, pvar d2, pshift sv));
extern bool VDIsSame ARGS((pvar d1, pvar d2));
extern bool VDIsSubSet ARGS((pvar vard1, pvar vard2));
extern bool VDIsSubTopDim ARGS((pvar vard1, pvar vard2, int top_dim));
extern void VDIsTopDimAligned ARGS((pvar vard1, pvar vard2, int top_dim, bool * yyP2, int * yyP1));
extern bool VDIsAligned ARGS((pvar vard1, pvar vard2));

extern void BeginMoveDescriptor ();
extern void CloseMoveDescriptor ();

# endif
