# ifndef yyObjects
# define yyObjects

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifndef bool
# define bool char
# endif

# include "Tree.h"
# include "Definitions.h"


extern void (* Objects_Exit) ();

extern tDefinitions MakeNewObject ARGS((tTree decl, tDefinitions unit));
extern tDefinitions MakeResultObject ARGS((tTree decl, tDefinitions unit));
extern bool IsVarAllocatable ARGS((tDefinitions v));
extern bool IsVarAssumedShape ARGS((tDefinitions v));
extern bool IsVarAssumedSize ARGS((tDefinitions v));
extern bool IsVarCommon ARGS((tDefinitions v));
extern bool IsVarDummy ARGS((tDefinitions v));
extern bool IsVarResult ARGS((tDefinitions v));
extern bool IsVarParameter ARGS((tDefinitions v));
extern bool IsVarLocal ARGS((tDefinitions v));
extern bool IsVarTraced ARGS((tDefinitions v));
extern bool IsTreeObject ARGS((tDefinitions v));
extern bool IsRaggedVarObject ARGS((tDefinitions v));
extern bool IsTemplate ARGS((tDefinitions v));
extern bool IsTopology ARGS((tDefinitions v));
extern bool IsOptional ARGS((tDefinitions v));
extern bool IsVarOverlapped ARGS((tDefinitions v));
extern bool IsArrayOverlapped ARGS((tTree t));
extern bool IsFuncObj ARGS((tDefinitions v));
extern bool IsModuleObj ARGS((tDefinitions v));
extern bool IsTypeObj ARGS((tDefinitions v));
extern bool IsLocalCall ARGS((tTree t));
extern bool IsSerialCall ARGS((tTree t));
extern bool IsF77Call ARGS((tTree t));
extern bool IsUserCall ARGS((tTree t));
extern bool IsIntrCall ARGS((tTree t));
extern bool IsStmtCall ARGS((tTree t));
extern bool IsPureCall ARGS((tTree t));
extern bool IsPureUnit ARGS((tTree t));
extern bool IsLocalUnit ARGS((tTree t));
extern bool IsSerialUnit ARGS((tTree t));
extern bool IsF77Unit ARGS((tTree t));
extern bool IsMainUnit ARGS((tTree t));
extern bool IsStmtFunction ARGS((tDefinitions obj));
extern tDefinitions GetFuncVarObj ARGS((tDefinitions f));
extern void GetDummies ARGS((tDefinitions obj, tTree * yyP2, tDefinitions * yyP1));
extern tDefinitions GetReferenceObject ARGS((tDefinitions obj));
extern bool NoInterfaceObj ARGS((tDefinitions v));
extern bool FunctionBecomesSubroutine ARGS((tTree f));
extern bool IsUsedObject ARGS((tDefinitions obj, tDefinitions unit));

extern void BeginObjects ();
extern void CloseObjects ();

# endif
