/* $Id: Parser.c,v 2.9 1992/08/07 15:28:42 grosch rel $ */

# define bool		char
# define true		1
# define false		0

# include "Parser.h"
# include "Errors.h"

# ifdef __cplusplus
extern "C" {
#    include "Memory.h"
#    include "DynArray.h"
#    include "Sets.h"
#    ifndef BCOPY
#       include <memory.h>
#    endif
}
# else
#    include "Memory.h"
#    include "DynArray.h"
#    include "Sets.h"
#    ifndef BCOPY
#       include <memory.h>
#    endif
# endif

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifdef lex_interface
#    define GetToken	yylex
     extern int yylex ();
#    ifndef AttributeDef
#	include "Positions.h"
        typedef struct { tPosition Position; } tScanAttribute;
        static	tScanAttribute	Attribute = {{ 0, 0 }};
#    endif
#    ifndef ErrorAttributeDef
#	define ErrorAttribute(Token, RepairAttribute)
#    endif
#    ifndef yyGetAttribute
#	define yyGetAttribute(yyAttrStackPtr, Attribute) * yyAttrStackPtr = yylval
#    endif
# else
#    include "Scanner.h"
#    ifndef yyGetAttribute
#	define yyGetAttribute(yyAttrStackPtr, Attribute) (yyAttrStackPtr)->Scan = Attribute
#    endif
# endif

/* line 58 "fortran.lalr" */


#include <stdio.h>
#include "global.h"
#include "MySource.h"  /* CodeLine, GetPosition */
#include "Tree.h"
#include "BuildTree.h"
#include "labels.h"

#define NLine(a) MyCodeLine(a.Scan.Position.Line)

   /********************************************************
   *                                                       *
   *     Special functions for abstract syntax trees       *
   *                                                       *
   ********************************************************/

typedef struct { tScanAttribute Scan;
                 int Label;
                 int Line;
                 tTree Tree;         } tParsAttribute;


# if defined lex_interface & ! defined yylvalDef
     tParsAttribute yylval;
# endif

# ifndef yyInitStackSize
#    define yyInitStackSize	100
# endif
# define yyNoState		0

# define yyFirstTerminal	0
# define yyLastTerminal		255
# define yyTableMax		2232
# define yyNTableMax		5412
# define yyFirstReadState	1
# define yyLastReadState	850
# define yyFirstReadTermState	851
# define yyLastReadTermState	1048
# define yyLastReadNontermState	1475
# define yyFirstReduceState	1476
# define yyLastReduceState	2302
# define yyStartState		1
# define yyStopState		1476

# define yyFirstFinalState	yyFirstReadTermState

typedef unsigned short	yyStateRange	;
typedef unsigned short	yySymbolRange	;
typedef struct	{ yyStateRange Check, Next; } yyTCombType ;

	char *		Parser_TokenName	[yyLastTerminal + 1] = {
"_EndOfFile",
"Ident",
"IntConst",
"RealConst",
"DRealConst",
"StringConst",
0,
"UserOp",
0,
0,
"=",
"//",
"=>",
"(",
")",
"+",
"-",
"*",
"/",
"**",
":",
",",
0,
"[",
"]",
0,
0,
"::",
".",
"%",
"<>",
"==",
">",
">=",
"<",
"<=",
"AND",
"OR",
0,
"EQV",
"NEQV",
"TRUE",
"FALSE",
"NOT",
"XOR",
"BLOCKDATA",
"DATA",
0,
"INTRINSIC",
0,
"INTEGER",
"REAL",
"COMPLEX",
"LOGICAL",
"CHARACTER",
"DOUBLE_PRECISION",
"DOUBLE_COMPLEX",
"SAVE",
"IMPLICIT",
"EXTERNAL",
"PARAMETER",
"DIMENSION",
"COMMON",
"EQUIVALENCE",
"PROGRAM",
"RECURSIVE",
"SUBROUTINE",
"FUNCTION",
"END",
"DO",
"WHILE",
"IF",
"THEN",
"ELSE",
"ELSEIF",
"ENDDO",
"ENDIF",
"RESULT",
"ASSIGN",
"TO",
"CALL",
"CONTINUE",
"STOP",
"RETURN",
0,
"FORMAT",
"FORMAT_ARG",
"GOTO",
"ENTRY",
0,
"READ",
"WRITE",
"PRINT",
"OPEN",
"CLOSE",
"INQUIRE",
"BACKSPACE",
"ENDFILE",
"REWIND",
0,
"ALLOCATE",
"DEALLOCATE",
"WHERE",
"ENDWHERE",
"ELSEWHERE",
"SELECTCASE",
"CASE",
"DEFAULT",
0,
"FORALL",
"INTENT",
"IN",
"OUT",
"INOUT",
"ENDFORALL",
"CYCLE",
"EXIT",
0,
0,
0,
0,
"REDUCE",
0,
0,
0,
"PROCEDURE",
"OPERATOR",
"ASSIGNMENT",
0,
0,
"TYPE",
"ENDTYPE",
"INTERFACE",
"ENDINTERFACE",
"MODULE",
0,
"CONTAINS",
"USE",
"ONLY",
0,
"ALLOCATABLE",
"OPTIONAL",
"POINTER",
"TARGET",
"PUBLIC",
"PRIVATE",
"NULLIFY",
"NAMELIST",
"SEQUENCE",
0,
0,
"ALIGN",
"WITH",
"REALIGN",
"DISTRIBUTE",
"REDISTRIBUTE",
"PROCESSORS",
"TEMPLATE",
"DYNAMIC",
"ONTO",
"BLOCK",
"CYCLIC",
"NOSEQUENCE",
"HPFSEQUENCE",
"INDEPENDENT",
"RESIDENT",
"ON",
"NEW",
"REDUCTION",
"INHERIT",
"HOME",
0,
0,
0,
0,
0,
0,
0,
0,
0,
"PURE",
"EXTRINSIC",
0,
0,
0,
0,
0,
0,
0,
0,
0,
"DIMENSION1",
"PARAMETER1",
"INTENT1",
"EXTERNAL1",
"INTRINSIC1",
"OPTIONAL1",
"POINTER1",
"SAVE1",
"TARGET1",
"DATA1",
"PUBLIC1",
"PRIVATE1",
"ALLOCATABLE1",
"ARRAY1",
"ENDSELECT",
"SEQUENCE1",
0,
"GEN_BLOCK",
"INDIRECT",
"HPF_BEGIN",
"HPF_END",
"TASK_REGION",
0,
"RANGE",
"ALL",
"LAYOUT",
"PASS_BY",
"MAP_TO",
"ARBITRARY",
"MAP",
"SHADOW",
"SHARED",
"RMA",
"TRACE",
"TREE",
"SELECT",
"NOVECTOR",
"NOCONCUR",
"SHORT",
"EXPAND",
"VECTOR",
"CONCUR",
"SKIP",
0,
0,
0,
0,
0,
0,
"LAYOUT1",
"PASS_BY1",
"MAP_TO1",
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
"NewLine",
};
yyTCombType	yyTComb		[yyTableMax + 1] = {
{839, 1512},
{1, 1479},
{107, 926},
{328, 9},
{343, 996},
{100, 924},
{102, 925},
{25, 881},
{125, 887},
{237, 238},
{16, 17},
{69, 70},
{110, 102},
{31, 32},
{15, 885},
{18, 2228},
{24, 25},
{8, 77},
{20, 11},
{20, 13},
{16, 2219},
{33, 900},
{18, 2228},
{48, 2227},
{16, 2219},
{18, 2228},
{52, 2233},
{16, 2219},
{49, 2225},
{51, 52},
{48, 2227},
{57, 906},
{56, 2233},
{48, 2227},
{53, 2234},
{49, 50},
{51, 56},
{60, 907},
{49, 2225},
{56, 2233},
{53, 2234},
{53, 2234},
{56, 2233},
{64, 2219},
{53, 2234},
{1, 1479},
{1, 1479},
{53, 2234},
{1, 1479},
{65, 66},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{62, 908},
{1, 1479},
{68, 66},
{5, 1479},
{5, 1479},
{5, 1479},
{5, 1479},
{62, 63},
{1, 1479},
{71, 72},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{75, 2139},
{1, 1479},
{76, 910},
{1, 1479},
{1, 1479},
{77, 911},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{79, 80},
{1, 1479},
{1, 1479},
{1, 1479},
{5, 1479},
{5, 1479},
{1, 1479},
{5, 1479},
{80, 912},
{81, 913},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{5, 1479},
{1, 1479},
{1, 1479},
{54, 2230},
{82, 914},
{84, 916},
{85, 1650},
{1, 1479},
{86, 917},
{54, 55},
{54, 2230},
{89, 920},
{90, 922},
{54, 2230},
{91, 1562},
{92, 921},
{1, 1479},
{5, 1479},
{1, 1479},
{5, 1479},
{1, 1479},
{91, 92},
{1, 1479},
{1, 1479},
{95, 96},
{97, 923},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{5, 1479},
{99, 100},
{101, 1552},
{1, 1479},
{103, 104},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{113, 930},
{123, 124},
{126, 934},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{108, 1548},
{124, 1600},
{127, 1596},
{128, 122},
{129, 887},
{130, 1600},
{131, 1602},
{108, 109},
{124, 1600},
{127, 128},
{1, 1479},
{1, 1479},
{130, 1600},
{131, 132},
{132, 932},
{133, 134},
{134, 933},
{129, 130},
{3, 4},
{135, 136},
{137, 138},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{5, 1479},
{1, 1479},
{3, 87},
{3, 94},
{3, 1541},
{3, 1541},
{5, 1479},
{1, 1479},
{138, 139},
{1, 1479},
{143, 940},
{1, 1479},
{1, 1479},
{1, 1479},
{7, 1585},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{30, 9},
{30, 878},
{30, 879},
{30, 880},
{7, 8},
{112, 927},
{112, 928},
{145, 939},
{150, 151},
{152, 153},
{112, 929},
{30, 10},
{7, 1585},
{1, 1479},
{1, 1479},
{1, 1479},
{73, 2138},
{144, 1942},
{7, 1585},
{147, 1933},
{153, 154},
{30, 12},
{159, 942},
{73, 74},
{144, 145},
{160, 943},
{147, 148},
{162, 944},
{1, 2},
{4, 5},
{6, 5},
{93, 5},
{115, 5},
{117, 5},
{118, 5},
{156, 935},
{163, 945},
{164, 165},
{165, 946},
{30, 882},
{30, 883},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{166, 947},
{30, 884},
{3, 833},
{167, 168},
{158, 159},
{158, 1964},
{168, 948},
{9, 2290},
{7, 1585},
{7, 1585},
{7, 1585},
{9, 2290},
{158, 1964},
{169, 949},
{9, 2290},
{9, 2290},
{9, 2290},
{9, 2290},
{170, 171},
{9, 2290},
{9, 2290},
{161, 162},
{161, 1967},
{171, 951},
{9, 2290},
{172, 173},
{174, 175},
{9, 2290},
{176, 952},
{161, 1967},
{9, 2290},
{9, 2290},
{9, 2290},
{9, 2290},
{9, 2290},
{9, 2290},
{9, 2290},
{9, 2290},
{146, 142},
{9, 2290},
{9, 2290},
{177, 953},
{182, 954},
{183, 184},
{9, 2290},
{187, 955},
{146, 1940},
{191, 1952},
{3, 98},
{3, 99},
{75, 2139},
{178, 1962},
{146, 1940},
{135, 149},
{7, 1585},
{7, 1585},
{7, 1585},
{14, 2285},
{178, 179},
{193, 1873},
{194, 195},
{14, 2285},
{206, 207},
{197, 1868},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{184, 1956},
{7, 1585},
{14, 2285},
{198, 199},
{202, 935},
{14, 2285},
{184, 1956},
{201, 202},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{21, 2256},
{14, 2285},
{14, 2285},
{192, 1995},
{196, 1994},
{208, 956},
{14, 2285},
{21, 2256},
{204, 205},
{192, 1995},
{196, 1994},
{150, 155},
{200, 1990},
{21, 2256},
{21, 2256},
{203, 1991},
{212, 213},
{21, 2256},
{200, 1990},
{217, 957},
{21, 2256},
{203, 1991},
{220, 221},
{21, 889},
{21, 890},
{21, 891},
{21, 892},
{21, 893},
{21, 894},
{21, 2256},
{21, 2256},
{188, 186},
{21, 2256},
{21, 2256},
{211, 1927},
{7, 1585},
{7, 1585},
{21, 2256},
{222, 958},
{188, 1957},
{211, 1927},
{223, 224},
{227, 228},
{229, 961},
{230, 231},
{188, 1957},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{34, 2241},
{7, 1585},
{180, 181},
{232, 966},
{216, 1881},
{156, 938},
{233, 234},
{34, 2241},
{218, 1879},
{235, 975},
{180, 1961},
{216, 1881},
{214, 1882},
{34, 2241},
{34, 2241},
{218, 219},
{180, 1961},
{34, 2241},
{214, 215},
{214, 1882},
{34, 2241},
{236, 237},
{238, 976},
{239, 240},
{240, 241},
{23, 2265},
{241, 977},
{242, 243},
{243, 244},
{23, 2265},
{244, 978},
{248, 122},
{23, 2265},
{249, 980},
{245, 226},
{7, 1585},
{7, 1585},
{7, 1585},
{23, 2265},
{23, 2265},
{245, 1655},
{254, 1646},
{23, 2265},
{257, 981},
{255, 256},
{23, 2265},
{258, 5},
{259, 5},
{23, 2265},
{23, 2265},
{23, 2265},
{23, 2265},
{23, 2265},
{23, 2265},
{23, 2265},
{23, 2265},
{26, 2274},
{23, 2265},
{23, 2265},
{247, 1641},
{26, 2274},
{73, 2138},
{23, 2265},
{26, 2274},
{26, 2274},
{26, 2274},
{247, 1641},
{250, 1643},
{260, 261},
{26, 2274},
{26, 2274},
{261, 1805},
{263, 264},
{26, 2274},
{250, 251},
{266, 267},
{26, 2274},
{270, 136},
{250, 1643},
{26, 2274},
{26, 2274},
{26, 2274},
{26, 2274},
{26, 2274},
{26, 2274},
{26, 2274},
{26, 2274},
{271, 183},
{26, 2274},
{26, 2274},
{268, 269},
{28, 2279},
{272, 207},
{26, 2274},
{202, 938},
{28, 2279},
{268, 1982},
{273, 213},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 899},
{28, 2279},
{28, 2279},
{276, 277},
{9, 2290},
{28, 2279},
{275, 276},
{275, 279},
{28, 2279},
{278, 987},
{279, 280},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 2279},
{36, 2243},
{28, 2279},
{28, 2279},
{280, 281},
{265, 248},
{251, 915},
{28, 2279},
{36, 2243},
{38, 2247},
{281, 988},
{146, 1940},
{282, 5},
{265, 1641},
{36, 2243},
{36, 2243},
{38, 2247},
{251, 84},
{36, 2243},
{252, 253},
{287, 288},
{36, 2243},
{38, 2247},
{38, 2247},
{193, 1873},
{194, 1871},
{38, 2247},
{180, 1961},
{197, 1868},
{38, 2247},
{252, 1645},
{286, 287},
{288, 289},
{36, 2243},
{36, 2243},
{290, 291},
{14, 2285},
{184, 1956},
{292, 989},
{38, 2247},
{198, 1866},
{38, 2247},
{38, 2247},
{293, 294},
{201, 1947},
{40, 2264},
{38, 2247},
{294, 295},
{295, 990},
{40, 2264},
{299, 290},
{299, 293},
{40, 2264},
{40, 895},
{40, 896},
{296, 1730},
{300, 297},
{306, 1788},
{40, 2264},
{40, 2264},
{306, 1788},
{204, 1922},
{40, 2264},
{307, 308},
{298, 299},
{40, 2264},
{309, 310},
{21, 2256},
{40, 2264},
{40, 2264},
{40, 2264},
{40, 2264},
{40, 2264},
{40, 2264},
{40, 2264},
{40, 2264},
{41, 2267},
{40, 2264},
{40, 2264},
{311, 312},
{41, 2267},
{301, 302},
{40, 2264},
{41, 2267},
{41, 2267},
{41, 2267},
{313, 991},
{211, 1927},
{315, 305},
{41, 2267},
{41, 2267},
{316, 317},
{188, 1957},
{41, 2267},
{223, 1876},
{270, 149},
{41, 2267},
{323, 909},
{321, 887},
{41, 2267},
{41, 2267},
{41, 2267},
{41, 2267},
{41, 2267},
{41, 2267},
{41, 2267},
{41, 2267},
{329, 993},
{41, 2267},
{41, 2267},
{337, 1749},
{42, 2246},
{321, 322},
{41, 2267},
{340, 995},
{318, 319},
{318, 2290},
{275, 1829},
{42, 2246},
{318, 2290},
{325, 326},
{325, 878},
{325, 879},
{180, 1961},
{42, 2246},
{42, 2246},
{324, 9},
{34, 2241},
{42, 2246},
{324, 880},
{335, 336},
{42, 2246},
{327, 328},
{327, 1794},
{341, 342},
{326, 2301},
{327, 1794},
{324, 320},
{326, 2301},
{342, 339},
{42, 905},
{42, 2246},
{43, 2242},
{42, 2246},
{42, 2246},
{326, 877},
{346, 347},
{330, 1792},
{42, 2246},
{43, 2242},
{330, 331},
{350, 997},
{23, 2265},
{353, 354},
{254, 1646},
{43, 2242},
{43, 2242},
{255, 1638},
{332, 1786},
{43, 2242},
{344, 1585},
{332, 333},
{43, 2242},
{345, 1581},
{344, 83},
{324, 882},
{324, 883},
{345, 107},
{355, 998},
{207, 941},
{358, 357},
{351, 1712},
{43, 903},
{44, 2273},
{43, 2242},
{43, 2242},
{360, 361},
{44, 2273},
{351, 352},
{43, 904},
{44, 2273},
{44, 2273},
{44, 2273},
{26, 2274},
{362, 363},
{364, 365},
{44, 2273},
{44, 2273},
{266, 1979},
{367, 999},
{44, 2273},
{250, 1643},
{370, 121},
{44, 2273},
{372, 121},
{376, 1001},
{44, 2273},
{44, 2273},
{44, 2273},
{44, 2273},
{44, 2273},
{44, 2273},
{44, 2273},
{44, 2273},
{377, 1002},
{44, 2273},
{44, 2273},
{46, 2257},
{366, 1803},
{47, 2239},
{44, 2273},
{46, 888},
{368, 1801},
{373, 374},
{46, 2257},
{366, 1803},
{47, 2239},
{381, 1506},
{28, 2279},
{368, 369},
{46, 2257},
{46, 2257},
{47, 2239},
{47, 2239},
{46, 2257},
{383, 384},
{47, 2239},
{46, 2257},
{348, 1714},
{47, 2239},
{348, 349},
{391, 392},
{396, 1003},
{397, 398},
{398, 390},
{348, 1714},
{46, 2257},
{46, 2257},
{399, 400},
{46, 2257},
{46, 2257},
{47, 901},
{47, 902},
{400, 2112},
{46, 2257},
{379, 1688},
{59, 2270},
{265, 1641},
{379, 1688},
{36, 2243},
{59, 2270},
{401, 402},
{403, 404},
{59, 2270},
{59, 2270},
{59, 2270},
{404, 405},
{38, 2247},
{388, 1505},
{59, 2270},
{59, 2270},
{388, 381},
{406, 407},
{59, 2270},
{252, 1645},
{286, 1699},
{59, 2270},
{427, 1725},
{435, 1004},
{59, 2270},
{59, 2270},
{59, 2270},
{59, 2270},
{59, 2270},
{59, 2270},
{59, 2270},
{59, 2270},
{61, 2269},
{59, 2270},
{59, 2270},
{410, 1770},
{61, 2269},
{440, 434},
{59, 2270},
{61, 2269},
{61, 2269},
{61, 2269},
{61, 897},
{61, 898},
{296, 1730},
{61, 2269},
{61, 2269},
{395, 1684},
{40, 2264},
{61, 2269},
{443, 1761},
{446, 1005},
{61, 2269},
{298, 1702},
{395, 394},
{61, 2269},
{61, 2269},
{61, 2269},
{61, 2269},
{61, 2269},
{61, 2269},
{61, 2269},
{61, 2269},
{448, 445},
{61, 2269},
{61, 2269},
{452, 1006},
{207, 158},
{207, 161},
{61, 2269},
{301, 1699},
{411, 412},
{67, 2219},
{454, 451},
{455, 456},
{67, 2137},
{67, 2219},
{456, 457},
{67, 2219},
{41, 2267},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{457, 458},
{67, 2219},
{357, 873},
{357, 874},
{357, 875},
{357, 876},
{357, 344},
{357, 918},
{357, 919},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{262, 7},
{67, 2219},
{67, 2219},
{402, 963},
{402, 964},
{402, 965},
{67, 2219},
{262, 120},
{415, 416},
{419, 1780},
{420, 421},
{42, 2246},
{207, 164},
{207, 167},
{106, 1581},
{424, 1775},
{335, 1721},
{425, 426},
{429, 430},
{207, 950},
{341, 1751},
{78, 2219},
{442, 438},
{207, 170},
{78, 79},
{78, 2219},
{106, 8},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{106, 1581},
{431, 1507},
{431, 1507},
{449, 1507},
{462, 463},
{463, 464},
{106, 1581},
{464, 465},
{43, 2242},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{467, 468},
{78, 2219},
{78, 2219},
{468, 469},
{358, 1708},
{469, 470},
{78, 2219},
{447, 448},
{453, 454},
{460, 461},
{360, 1717},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{111, 1807},
{473, 474},
{492, 493},
{44, 2273},
{475, 1886},
{494, 495},
{262, 95},
{262, 1810},
{106, 1581},
{106, 1581},
{106, 1581},
{331, 318},
{331, 878},
{331, 879},
{331, 880},
{478, 1992},
{225, 1652},
{476, 477},
{479, 480},
{482, 483},
{111, 112},
{478, 1992},
{331, 320},
{495, 496},
{331, 324},
{331, 325},
{111, 931},
{262, 135},
{486, 487},
{373, 1677},
{262, 156},
{490, 491},
{262, 192},
{262, 196},
{262, 200},
{481, 1993},
{499, 1900},
{46, 2257},
{503, 504},
{47, 2239},
{501, 1904},
{481, 1993},
{225, 979},
{499, 500},
{501, 502},
{262, 203},
{504, 1007},
{501, 1904},
{505, 1015},
{397, 1681},
{331, 882},
{331, 883},
{507, 1532},
{508, 5},
{106, 1581},
{106, 1581},
{106, 1581},
{502, 1008},
{502, 1009},
{502, 1010},
{502, 1011},
{502, 1012},
{502, 1013},
{502, 1014},
{379, 1688},
{506, 507},
{514, 304},
{269, 120},
{515, 516},
{517, 518},
{497, 498},
{518, 606},
{519, 520},
{106, 1581},
{521, 522},
{522, 1017},
{59, 2270},
{388, 1690},
{406, 1848},
{524, 525},
{226, 227},
{226, 962},
{226, 230},
{226, 967},
{226, 968},
{226, 969},
{226, 970},
{226, 971},
{226, 972},
{226, 973},
{262, 206},
{509, 2000},
{226, 974},
{226, 233},
{431, 1724},
{528, 1018},
{410, 1770},
{262, 212},
{262, 959},
{262, 960},
{534, 1019},
{530, 531},
{535, 2063},
{527, 528},
{537, 2040},
{514, 399},
{532, 2065},
{61, 2269},
{533, 2066},
{535, 536},
{111, 1807},
{111, 1807},
{111, 1807},
{532, 2065},
{538, 2041},
{533, 2066},
{539, 2043},
{540, 2044},
{545, 546},
{548, 2036},
{550, 551},
{552, 1021},
{541, 1017},
{106, 1581},
{106, 1581},
{314, 1505},
{225, 1652},
{225, 1652},
{225, 1652},
{226, 236},
{226, 239},
{226, 242},
{411, 1768},
{541, 542},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{543, 2034},
{106, 1581},
{553, 554},
{555, 556},
{556, 1024},
{559, 1025},
{557, 2100},
{543, 544},
{561, 1023},
{269, 270},
{562, 2083},
{509, 2000},
{269, 271},
{557, 2100},
{269, 982},
{269, 983},
{269, 984},
{274, 1814},
{274, 1814},
{274, 1814},
{274, 1814},
{274, 1814},
{274, 1814},
{274, 1814},
{415, 1734},
{419, 1780},
{420, 1778},
{269, 985},
{274, 1814},
{563, 2109},
{564, 565},
{424, 1775},
{558, 2099},
{425, 1773},
{429, 1728},
{106, 1581},
{106, 1581},
{106, 1581},
{442, 1744},
{558, 2099},
{569, 2077},
{575, 554},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{449, 1755},
{111, 1807},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{269, 272},
{225, 1652},
{549, 1505},
{447, 1763},
{453, 1757},
{460, 1740},
{560, 2097},
{269, 273},
{269, 959},
{269, 960},
{549, 992},
{566, 567},
{375, 1696},
{560, 561},
{571, 572},
{314, 1505},
{314, 1505},
{314, 1505},
{475, 1886},
{111, 1807},
{111, 1807},
{111, 1807},
{375, 1000},
{577, 2095},
{570, 1017},
{274, 1814},
{274, 1814},
{570, 1022},
{580, 581},
{375, 376},
{579, 1027},
{476, 1884},
{479, 1914},
{482, 1918},
{506, 1533},
{225, 1652},
{225, 1652},
{225, 1652},
{582, 1028},
{570, 1026},
{274, 117},
{579, 554},
{486, 1888},
{274, 118},
{586, 1029},
{490, 1892},
{274, 1814},
{588, 589},
{590, 591},
{274, 1814},
{291, 986},
{274, 1814},
{274, 1814},
{274, 1814},
{291, 888},
{303, 304},
{592, 2048},
{303, 334},
{291, 895},
{291, 896},
{291, 897},
{291, 898},
{291, 899},
{584, 585},
{274, 1814},
{488, 1507},
{303, 337},
{303, 343},
{303, 359},
{303, 362},
{303, 370},
{303, 375},
{303, 389},
{291, 889},
{291, 890},
{291, 891},
{291, 892},
{291, 893},
{291, 894},
{291, 905},
{291, 903},
{593, 2046},
{291, 901},
{291, 902},
{497, 1897},
{594, 595},
{291, 886},
{291, 904},
{595, 529},
{596, 1030},
{597, 598},
{488, 994},
{597, 600},
{599, 2037},
{303, 399},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{274, 1814},
{314, 1505},
{601, 887},
{602, 603},
{604, 605},
{605, 1017},
{606, 1510},
{274, 1814},
{274, 1814},
{274, 1814},
{303, 401},
{607, 5},
{610, 1510},
{375, 1696},
{375, 1696},
{375, 1696},
{527, 2060},
{530, 2219},
{532, 2065},
{611, 5},
{533, 2066},
{613, 5},
{612, 1509},
{615, 616},
{617, 618},
{618, 619},
{619, 1510},
{620, 5},
{621, 2002},
{621, 2002},
{622, 610},
{622, 615},
{623, 624},
{622, 2151},
{624, 1510},
{314, 1505},
{314, 1505},
{314, 1505},
{628, 629},
{630, 1031},
{303, 408},
{303, 413},
{303, 417},
{303, 422},
{303, 427},
{303, 431},
{631, 632},
{303, 433},
{633, 634},
{634, 5},
{314, 1783},
{303, 135},
{612, 2002},
{639, 640},
{303, 156},
{637, 638},
{303, 192},
{303, 196},
{303, 200},
{640, 5},
{641, 2000},
{612, 1509},
{303, 443},
{303, 449},
{642, 2156},
{642, 637},
{488, 1507},
{488, 1507},
{488, 1507},
{303, 203},
{643, 5},
{645, 2000},
{646, 1032},
{647, 648},
{614, 2002},
{614, 2002},
{614, 2002},
{614, 2002},
{649, 650},
{650, 5},
{651, 652},
{652, 653},
{563, 2109},
{564, 2107},
{655, 2169},
{657, 2168},
{659, 1033},
{661, 654},
{662, 1510},
{663, 5},
{665, 1510},
{655, 2169},
{657, 2168},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{614, 2002},
{375, 1696},
{666, 5},
{668, 669},
{669, 1510},
{658, 2170},
{670, 2160},
{303, 206},
{614, 2002},
{303, 455},
{303, 462},
{303, 467},
{658, 2170},
{303, 472},
{303, 212},
{303, 478},
{303, 481},
{303, 484},
{303, 488},
{303, 492},
{656, 2167},
{671, 672},
{674, 523},
{660, 2165},
{580, 583},
{675, 1509},
{656, 657},
{656, 2167},
{549, 2032},
{566, 2081},
{660, 661},
{673, 887},
{571, 2079},
{676, 1034},
{677, 678},
{375, 1696},
{375, 1696},
{375, 1696},
{673, 674},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{680, 886},
{488, 1507},
{511, 2135},
{511, 1016},
{681, 682},
{510, 511},
{584, 587},
{510, 515},
{667, 1509},
{644, 1509},
{679, 674},
{675, 1509},
{683, 684},
{685, 2058},
{686, 1035},
{652, 662},
{687, 688},
{679, 680},
{689, 2059},
{512, 1505},
{690, 2055},
{694, 695},
{511, 2135},
{695, 696},
{510, 625},
{689, 2059},
{692, 693},
{690, 691},
{697, 140},
{693, 936},
{698, 693},
{644, 2002},
{693, 937},
{699, 700},
{701, 702},
{488, 1507},
{488, 1507},
{488, 1507},
{510, 631},
{512, 992},
{675, 2002},
{510, 647},
{704, 1952},
{706, 183},
{707, 708},
{510, 671},
{614, 2002},
{667, 1509},
{644, 1509},
{709, 710},
{705, 157},
{711, 2217},
{614, 2002},
{591, 519},
{705, 180},
{717, 1036},
{712, 718},
{510, 681},
{712, 733},
{722, 723},
{591, 523},
{723, 1037},
{591, 526},
{591, 1020},
{591, 537},
{591, 539},
{644, 2002},
{644, 2002},
{667, 2002},
{591, 541},
{724, 725},
{511, 2135},
{591, 553},
{591, 568},
{591, 570},
{591, 573},
{591, 574},
{591, 575},
{591, 576},
{591, 578},
{591, 579},
{726, 1039},
{591, 580},
{591, 584},
{591, 588},
{713, 714},
{728, 729},
{715, 2204},
{512, 1505},
{510, 692},
{601, 2038},
{510, 703},
{732, 1040},
{713, 2202},
{715, 716},
{720, 721},
{720, 1038},
{591, 592},
{591, 593},
{644, 2002},
{510, 711},
{510, 713},
{510, 745},
{510, 728},
{510, 733},
{733, 734},
{737, 1041},
{743, 992},
{721, 2233},
{730, 2127},
{744, 5},
{736, 15},
{511, 2135},
{511, 2135},
{511, 2135},
{721, 2233},
{730, 731},
{735, 2219},
{735, 2132},
{745, 719},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{735, 2132},
{546, 1505},
{736, 58},
{591, 594},
{512, 1505},
{512, 1505},
{512, 1505},
{546, 1505},
{735, 2219},
{546, 1505},
{546, 1505},
{738, 2130},
{637, 5},
{747, 713},
{706, 1952},
{546, 992},
{746, 747},
{546, 1505},
{738, 739},
{748, 749},
{749, 728},
{674, 5},
{751, 752},
{510, 2218},
{752, 753},
{740, 2221},
{740, 2133},
{754, 755},
{750, 2219},
{755, 606},
{750, 2219},
{750, 2219},
{757, 758},
{740, 2133},
{760, 5},
{546, 1505},
{546, 1505},
{546, 1505},
{750, 751},
{762, 763},
{692, 697},
{740, 2221},
{667, 2002},
{756, 511},
{698, 697},
{546, 1505},
{766, 5},
{750, 2219},
{763, 1042},
{704, 183},
{768, 769},
{769, 1043},
{772, 5},
{774, 775},
{775, 1044},
{759, 760},
{751, 647},
{765, 766},
{758, 511},
{771, 772},
{778, 5},
{780, 781},
{781, 1045},
{777, 778},
{783, 784},
{784, 5},
{786, 787},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{785, 1509},
{511, 2135},
{756, 671},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{758, 671},
{512, 1505},
{759, 5},
{787, 1046},
{765, 5},
{788, 789},
{771, 5},
{546, 1505},
{546, 1505},
{546, 1505},
{777, 5},
{789, 1510},
{790, 791},
{791, 792},
{713, 2202},
{713, 2202},
{713, 2202},
{713, 2202},
{511, 2135},
{511, 2135},
{511, 2135},
{793, 794},
{785, 1509},
{794, 5},
{796, 797},
{797, 1510},
{798, 799},
{800, 5},
{743, 1505},
{743, 1505},
{743, 1505},
{743, 1505},
{801, 1509},
{511, 2135},
{802, 803},
{512, 1505},
{512, 1505},
{512, 1505},
{803, 1510},
{763, 2194},
{804, 1567},
{805, 5},
{809, 89},
{769, 2199},
{775, 2209},
{701, 2175},
{807, 808},
{807, 811},
{810, 5},
{812, 1559},
{512, 5},
{781, 2214},
{813, 628},
{745, 724},
{814, 5},
{817, 1536},
{806, 7},
{816, 817},
{818, 5},
{713, 2202},
{709, 2182},
{801, 2002},
{819, 5},
{821, 1569},
{822, 1509},
{823, 1047},
{825, 826},
{806, 94},
{806, 1541},
{806, 1541},
{827, 5},
{801, 1509},
{828, 829},
{830, 1048},
{831, 1823},
{831, 825},
{834, 5},
{782, 1509},
{832, 1819},
{832, 1819},
{836, 837},
{837, 1527},
{838, 5},
{840, 1479},
{843, 1523},
{844, 5},
{847, 848},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{842, 843},
{546, 1505},
{848, 1557},
{713, 2202},
{849, 5},
{850, 1476},
{746, 2187},
{804, 805},
{0, 0},
{748, 2188},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{743, 2121},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{845, 873},
{845, 874},
{845, 875},
{845, 876},
{845, 7},
{845, 918},
{845, 919},
{806, 95},
{0, 0},
{0, 0},
{0, 0},
{546, 1505},
{546, 1505},
{546, 1505},
{833, 851},
{845, 94},
{845, 1541},
{845, 1541},
{0, 0},
{0, 0},
{782, 1509},
{0, 0},
{782, 1509},
{785, 2002},
{0, 0},
{0, 0},
{0, 0},
{746, 2187},
{0, 0},
{782, 1509},
{748, 2188},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{782, 1509},
{0, 0},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{0, 0},
{782, 1509},
{782, 1509},
{782, 1509},
{0, 0},
{0, 0},
{782, 1509},
{806, 98},
{806, 99},
{0, 0},
{782, 1509},
{0, 0},
{782, 1509},
{782, 1509},
{782, 1509},
{0, 0},
{782, 1509},
{782, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{0, 0},
{0, 0},
{0, 0},
{836, 1528},
{0, 0},
{0, 0},
{0, 0},
{845, 95},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{813, 1539},
{782, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{816, 1537},
{0, 0},
{0, 0},
{0, 0},
{833, 852},
{833, 853},
{833, 854},
{0, 0},
{0, 0},
{0, 0},
{845, 98},
{845, 99},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{0, 0},
{782, 1509},
{0, 0},
{809, 1559},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{0, 0},
{0, 0},
{0, 0},
{842, 1524},
{0, 0},
{0, 0},
{0, 0},
{847, 1558},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{0, 0},
{828, 1826},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{782, 1509},
{782, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{833, 855},
{833, 856},
{833, 857},
{833, 858},
{833, 859},
{833, 860},
{833, 861},
{833, 862},
{833, 863},
{833, 864},
{833, 865},
{833, 866},
{833, 867},
{833, 868},
{0, 0},
{833, 869},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 1509},
{0, 0},
{846, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 7},
{0, 0},
{0, 0},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{846, 1610},
{0, 0},
{846, 1610},
{0, 0},
{0, 0},
{0, 0},
{833, 870},
{833, 871},
{833, 872},
{846, 1610},
{0, 0},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{0, 0},
{846, 1509},
{0, 0},
{846, 1610},
{846, 1610},
{0, 0},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{0, 0},
{846, 1610},
{846, 1610},
{846, 1610},
{0, 0},
{0, 0},
{846, 1610},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{846, 1509},
{846, 1610},
{846, 1610},
{846, 1610},
{0, 0},
{846, 1610},
{846, 1610},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 111},
{0, 0},
{846, 275},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{846, 285},
{0, 0},
{0, 0},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1610},
{846, 1509},
{0, 0},
{0, 0},
{0, 0},
{846, 1509},
{0, 0},
{846, 1610},
{846, 1509},
{846, 1610},
{846, 1509},
{846, 1509},
{846, 1509},
{0, 0},
{0, 0},
{0, 0},
{846, 1509},
{846, 1509},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{0, 0},
{846, 1610},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{0, 0},
{846, 1509},
{0, 0},
{846, 1509},
{846, 1509},
{846, 1509},
{0, 0},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{846, 1610},
{846, 1610},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
};
unsigned short	yyNComb		[yyNTableMax - yyLastTerminal] = {
3,
1049,
850,
1464,
1051,
6,
1050,
1052,
1072,
88,
303,
78,
839,
1466,
1467,
1468,
1469,
1470,
840,
841,
93,
1077,
1079,
284,
1077,
807,
815,
97,
115,
845,
110,
1053,
116,
1091,
846,
1092,
150,
141,
509,
188,
185,
1149,
1076,
1082,
1150,
106,
1083,
1084,
82,
1085,
1075,
90,
91,
1053,
1078,
91,
1088,
108,
1449,
819,
1451,
1452,
1453,
1454,
1102,
1090,
1093,
1095,
62,
105,
1089,
101,
1103,
1124,
105,
146,
193,
1103,
1103,
1080,
1096,
16,
146,
105,
146,
106,
1083,
1084,
146,
1085,
106,
1083,
1084,
197,
1085,
103,
1086,
1087,
108,
106,
1083,
1084,
1053,
1085,
113,
225,
189,
14,
1053,
1081,
1127,
1094,
1130,
105,
1130,
246,
257,
1133,
48,
193,
232,
106,
1083,
1084,
197,
1085,
220,
14,
209,
106,
1083,
1084,
220,
1085,
1053,
1053,
245,
1144,
1053,
258,
1143,
250,
252,
1145,
1146,
1163,
283,
286,
1151,
14,
1187,
1181,
1186,
114,
119,
315,
1167,
338,
274,
16,
274,
259,
340,
1208,
300,
1211,
1210,
29,
27,
24,
22,
18,
22,
45,
37,
35,
39,
14,
1133,
20,
1216,
377,
1219,
1053,
1053,
372,
371,
1053,
383,
247,
378,
1053,
1178,
387,
247,
385,
48,
396,
14,
20,
1225,
397,
1224,
403,
14,
1226,
397,
1205,
409,
1053,
265,
1232,
379,
348,
414,
418,
1238,
379,
1136,
210,
423,
177,
1115,
182,
211,
1138,
1106,
1107,
1102,
208,
14,
166,
1053,
260,
169,
262,
1116,
1117,
178,
178,
178,
190,
1118,
1119,
1121,
1119,
178,
211,
1137,
20,
1114,
1166,
1241,
1113,
268,
14,
1154,
1155,
1156,
1157,
1158,
1159,
1160,
1161,
1162,
428,
1125,
194,
301,
1053,
255,
1148,
1139,
210,
1114,
255,
1147,
1217,
373,
14,
174,
1128,
198,
14,
432,
1212,
1222,
176,
436,
435,
137,
441,
147,
1053,
1108,
1109,
152,
147,
147,
1053,
1152,
1110,
20,
1111,
296,
14,
49,
1112,
1228,
1126,
194,
380,
1129,
198,
60,
1054,
382,
263,
1141,
223,
268,
1053,
350,
351,
1142,
223,
1227,
20,
14,
1134,
204,
1206,
341,
1120,
191,
1054,
1122,
1131,
201,
1132,
201,
19,
1139,
210,
1055,
1123,
1056,
282,
444,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
1055,
14,
1056,
1193,
19,
34,
43,
42,
1066,
1063,
21,
40,
41,
20,
1064,
28,
30,
1061,
31,
1065,
49,
1054,
1055,
1069,
1056,
14,
1135,
204,
57,
1248,
1053,
14,
1213,
360,
61,
19,
1064,
28,
30,
1061,
31,
1065,
1054,
1182,
1183,
298,
1185,
1192,
1054,
1065,
1055,
51,
1056,
14,
446,
34,
43,
42,
1066,
1063,
21,
40,
41,
1053,
1064,
28,
30,
1061,
31,
1065,
440,
1055,
348,
1056,
1054,
1054,
265,
1055,
1054,
1056,
364,
1164,
266,
59,
450,
1064,
28,
30,
1061,
31,
1065,
1058,
28,
30,
1061,
31,
1065,
327,
1205,
1054,
33,
1069,
296,
1055,
1055,
1056,
383,
1055,
34,
43,
42,
1066,
1063,
21,
40,
41,
1202,
1064,
28,
30,
1061,
31,
1065,
1054,
1054,
20,
14,
1054,
1055,
51,
1056,
1054,
1202,
34,
43,
42,
1066,
1063,
21,
40,
41,
452,
1064,
28,
30,
1061,
31,
1065,
1053,
1054,
348,
437,
1055,
1055,
1056,
1212,
1055,
459,
1060,
14,
1055,
1057,
21,
40,
41,
1252,
1064,
28,
30,
1061,
31,
1065,
1054,
1061,
31,
1065,
1053,
383,
1055,
466,
1056,
1209,
351,
47,
43,
42,
1066,
1063,
21,
40,
41,
1251,
1064,
28,
30,
1061,
31,
1065,
20,
471,
485,
1055,
489,
1056,
1221,
1184,
1183,
298,
1185,
1054,
503,
379,
23,
41,
508,
1064,
28,
30,
1061,
31,
1065,
383,
1207,
341,
379,
1053,
16,
367,
368,
1203,
335,
20,
1311,
1054,
440,
1312,
329,
440,
1055,
1054,
1056,
330,
1200,
364,
14,
1204,
335,
1248,
512,
1053,
44,
1067,
1064,
28,
30,
1061,
31,
1065,
1053,
355,
351,
1054,
1055,
48,
1056,
524,
1214,
360,
1055,
410,
1056,
1248,
14,
1194,
26,
1220,
1064,
28,
30,
1061,
31,
1065,
1059,
28,
30,
1061,
31,
1065,
513,
278,
1055,
790,
1056,
1253,
447,
53,
36,
42,
1066,
1063,
21,
40,
41,
1313,
1064,
28,
30,
1061,
31,
1065,
386,
1165,
266,
1053,
1229,
527,
20,
1179,
1180,
1223,
1053,
391,
14,
388,
1053,
1314,
284,
547,
807,
815,
372,
1229,
105,
67,
1054,
1168,
1169,
1170,
1171,
1172,
1173,
1174,
1175,
1176,
1177,
306,
1053,
410,
106,
1083,
1084,
1235,
1085,
1235,
14,
1250,
1194,
53,
1249,
345,
346,
353,
543,
1055,
545,
1056,
569,
1054,
327,
439,
38,
1066,
1063,
21,
40,
41,
550,
1064,
28,
30,
1061,
31,
1065,
53,
292,
1190,
314,
316,
1053,
332,
1215,
368,
1327,
442,
20,
543,
1055,
1316,
1056,
1233,
411,
34,
43,
42,
1066,
1063,
21,
40,
41,
306,
1064,
28,
30,
1061,
31,
1065,
14,
419,
1195,
1196,
306,
64,
1218,
373,
1328,
71,
20,
356,
1244,
306,
1168,
1169,
1170,
1171,
1172,
1173,
1174,
1175,
1176,
1177,
1244,
1053,
14,
67,
1053,
67,
1329,
1197,
1277,
1065,
1338,
49,
1054,
307,
345,
346,
353,
1339,
65,
1068,
1191,
314,
316,
604,
332,
824,
1252,
832,
1236,
415,
1237,
415,
514,
309,
313,
311,
549,
1234,
411,
1271,
1054,
1055,
68,
1056,
14,
419,
1230,
406,
20,
1062,
1063,
21,
40,
41,
1053,
1064,
28,
30,
1061,
31,
1065,
1195,
1198,
1231,
406,
1268,
1244,
1199,
1053,
1055,
424,
1056,
330,
1200,
20,
1258,
473,
14,
1255,
46,
40,
41,
358,
1064,
28,
30,
1061,
31,
1065,
1054,
1054,
1073,
1069,
1268,
429,
1053,
543,
306,
552,
306,
393,
14,
1365,
1246,
608,
73,
429,
1255,
1282,
501,
424,
1239,
420,
1054,
623,
1245,
20,
612,
1055,
1055,
51,
1056,
1054,
69,
34,
43,
42,
1066,
1063,
21,
40,
41,
75,
1064,
28,
30,
1061,
31,
1065,
1201,
1258,
332,
1055,
309,
1188,
311,
614,
69,
621,
20,
395,
1055,
54,
1056,
1254,
447,
34,
43,
42,
1066,
1063,
21,
40,
41,
14,
1064,
28,
30,
1061,
31,
1065,
1053,
429,
20,
1370,
626,
1265,
1054,
627,
1240,
420,
1247,
1265,
1197,
1054,
1065,
473,
1372,
1054,
630,
1271,
14,
1258,
1274,
1259,
460,
1274,
1054,
1053,
646,
645,
1317,
1242,
425,
1256,
453,
1055,
1320,
81,
641,
1054,
1278,
497,
1055,
1070,
1056,
1373,
1055,
34,
43,
42,
1066,
1063,
21,
40,
41,
1055,
1064,
28,
30,
1061,
31,
1065,
1257,
453,
85,
20,
1272,
486,
1055,
1071,
1056,
1243,
425,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
1260,
460,
1258,
1277,
20,
1053,
644,
1197,
14,
1065,
1367,
788,
613,
1263,
476,
1366,
1269,
482,
1366,
1197,
607,
1065,
1055,
611,
1056,
86,
1054,
34,
43,
42,
1066,
1063,
21,
40,
41,
14,
1064,
28,
30,
1061,
31,
1065,
125,
1318,
1270,
482,
1054,
1053,
1054,
1054,
1054,
651,
1261,
460,
1095,
1055,
1320,
1056,
76,
514,
34,
43,
42,
1066,
1063,
21,
40,
41,
1053,
1064,
28,
30,
1061,
31,
1065,
1055,
665,
1055,
1055,
1055,
20,
1056,
1074,
664,
34,
43,
42,
1066,
1063,
21,
40,
41,
667,
1064,
28,
30,
1061,
31,
1065,
1054,
1384,
14,
1386,
1366,
510,
123,
494,
20,
620,
499,
1281,
501,
126,
1054,
1097,
1098,
127,
146,
1100,
131,
146,
1262,
460,
1264,
476,
1266,
479,
1391,
1055,
1273,
486,
1267,
479,
804,
1275,
490,
1366,
1276,
490,
514,
1054,
1371,
1055,
577,
1056,
1053,
514,
34,
43,
42,
1066,
1063,
21,
40,
41,
514,
1064,
28,
30,
1061,
31,
1065,
1280,
706,
14,
499,
1281,
501,
510,
1055,
1103,
1056,
1382,
20,
34,
43,
42,
1066,
1063,
21,
40,
41,
129,
1064,
28,
30,
1061,
31,
1065,
510,
514,
505,
1099,
127,
499,
1281,
501,
636,
1053,
510,
668,
670,
19,
1366,
1366,
1366,
1279,
497,
663,
666,
1379,
1380,
670,
712,
1321,
1390,
1054,
1401,
642,
1053,
727,
16,
1395,
1119,
720,
1053,
712,
514,
1375,
1408,
514,
746,
562,
1409,
566,
133,
20,
1397,
1119,
1412,
712,
14,
764,
1054,
1101,
1055,
761,
1056,
1100,
131,
34,
43,
42,
1066,
1063,
21,
40,
41,
48,
1064,
28,
30,
1061,
31,
1065,
748,
1410,
1390,
1431,
1390,
675,
1053,
1055,
1053,
1056,
16,
514,
34,
43,
42,
1066,
1063,
21,
40,
41,
1394,
1064,
28,
30,
1061,
31,
1065,
770,
767,
14,
1053,
1367,
609,
613,
741,
742,
743,
712,
712,
1433,
776,
773,
510,
1435,
1054,
782,
1394,
48,
20,
510,
577,
779,
14,
1411,
1437,
510,
577,
1321,
785,
1366,
795,
801,
822,
1053,
1439,
806,
1330,
160,
809,
1331,
1441,
1388,
1053,
1055,
1389,
1056,
643,
571,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
1053,
1366,
757,
1412,
810,
1366,
1440,
510,
20,
597,
1442,
726,
1445,
14,
1054,
683,
163,
1413,
1367,
1368,
613,
812,
1055,
813,
814,
1367,
1369,
613,
1446,
818,
694,
20,
147,
14,
1367,
622,
613,
172,
1447,
1448,
820,
823,
830,
1055,
831,
1056,
1458,
643,
34,
43,
42,
1066,
1063,
21,
40,
41,
834,
1064,
28,
30,
1061,
31,
1065,
835,
303,
16,
685,
838,
643,
1367,
1374,
613,
506,
1462,
1457,
14,
1457,
1394,
643,
1460,
1463,
831,
1471,
225,
844,
20,
143,
144,
1105,
1472,
1473,
1054,
509,
849,
1474,
1475,
14,
0,
0,
106,
1083,
1084,
48,
1085,
0,
20,
1367,
1377,
613,
1367,
1378,
613,
1449,
819,
1451,
1452,
1453,
1454,
0,
798,
1055,
0,
1056,
514,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1053,
1064,
28,
30,
1061,
31,
1065,
1104,
144,
1105,
0,
1054,
1332,
0,
20,
1333,
744,
0,
1334,
0,
0,
1335,
1367,
676,
613,
1053,
0,
0,
14,
1402,
0,
0,
1054,
1381,
1054,
20,
1069,
216,
1054,
701,
1055,
1393,
1056,
1405,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1432,
1064,
28,
30,
1061,
31,
1065,
1434,
1055,
1053,
1055,
51,
1056,
1436,
1055,
34,
43,
42,
1066,
1063,
21,
40,
41,
514,
1064,
28,
30,
1061,
31,
1065,
0,
1054,
0,
1054,
1053,
1054,
0,
1069,
698,
699,
701,
0,
1392,
14,
0,
0,
214,
20,
827,
828,
1459,
828,
1406,
1407,
0,
1054,
686,
687,
1438,
709,
1055,
1399,
1055,
0,
1055,
51,
1056,
0,
730,
34,
43,
42,
1066,
1063,
21,
40,
41,
1053,
1064,
28,
30,
1061,
31,
1065,
1055,
709,
1056,
1398,
1054,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
49,
14,
0,
0,
1425,
1053,
1426,
0,
187,
0,
214,
20,
0,
1055,
1054,
704,
0,
1396,
0,
0,
0,
514,
1055,
0,
1056,
1053,
730,
34,
43,
42,
1066,
1063,
21,
40,
41,
1053,
1064,
28,
30,
1061,
31,
1065,
214,
1055,
514,
1056,
0,
1053,
34,
43,
42,
1066,
1063,
21,
40,
41,
514,
1064,
28,
30,
1061,
31,
1065,
514,
0,
0,
0,
735,
0,
14,
1367,
762,
613,
20,
1053,
1053,
0,
0,
0,
1054,
0,
1069,
0,
0,
123,
0,
0,
0,
0,
514,
0,
229,
0,
1097,
1098,
127,
0,
1100,
131,
217,
218,
14,
1053,
0,
0,
705,
707,
0,
1055,
51,
1056,
254,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
685,
1064,
28,
30,
1061,
31,
1065,
735,
0,
0,
715,
0,
0,
0,
0,
0,
0,
0,
123,
0,
20,
0,
14,
0,
0,
235,
1054,
1097,
1098,
127,
0,
1100,
131,
0,
0,
1367,
768,
613,
0,
0,
0,
0,
736,
0,
0,
1053,
1140,
218,
732,
14,
715,
1054,
20,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
14,
222,
218,
1055,
0,
123,
0,
0,
0,
0,
0,
1054,
249,
0,
1097,
1098,
127,
20,
1100,
131,
0,
0,
0,
0,
0,
0,
736,
0,
0,
0,
0,
0,
0,
1403,
0,
0,
1054,
0,
0,
0,
1055,
0,
1056,
0,
20,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
1367,
774,
613,
0,
14,
1055,
0,
0,
0,
1081,
1053,
0,
20,
105,
0,
0,
0,
0,
0,
1054,
0,
0,
0,
1367,
780,
613,
0,
0,
0,
106,
1083,
1084,
0,
1085,
0,
1367,
786,
613,
0,
1387,
687,
0,
1367,
796,
613,
0,
0,
71,
1055,
0,
1056,
1054,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
1367,
802,
613,
1054,
0,
0,
0,
0,
20,
246,
257,
0,
1055,
1054,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
1055,
0,
0,
0,
717,
0,
14,
0,
0,
0,
1055,
737,
738,
740,
0,
0,
0,
0,
0,
0,
1054,
1054,
1055,
0,
1056,
1053,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
1055,
0,
1400,
0,
0,
0,
1054,
1055,
1055,
1056,
0,
1189,
34,
43,
42,
1066,
1063,
21,
40,
41,
321,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
1404,
738,
740,
0,
0,
1055,
20,
1056,
0,
225,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
106,
1083,
1084,
0,
1085,
1053,
1055,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
0,
258,
0,
0,
0,
0,
0,
14,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
323,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
1283,
1284,
1285,
1286,
1287,
1288,
1289,
1290,
1291,
1292,
1293,
1294,
1295,
1296,
1297,
1298,
1299,
1300,
1301,
1302,
1303,
1304,
1305,
0,
1443,
1444,
0,
0,
0,
0,
0,
0,
20,
284,
0,
807,
815,
14,
0,
105,
0,
0,
1053,
0,
0,
0,
0,
0,
1153,
1053,
262,
1455,
821,
1054,
0,
106,
1083,
1084,
0,
1085,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1053,
0,
1154,
1155,
1156,
1157,
1158,
1159,
1160,
1161,
1162,
0,
0,
1055,
0,
1056,
0,
366,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
475,
0,
0,
20,
0,
0,
0,
0,
0,
0,
1154,
1155,
1156,
1157,
1158,
1159,
1160,
1161,
1162,
1306,
1307,
1308,
1309,
1310,
0,
0,
263,
0,
303,
268,
0,
0,
597,
0,
0,
0,
816,
0,
0,
14,
0,
0,
0,
0,
0,
0,
0,
225,
0,
0,
0,
0,
0,
0,
0,
0,
509,
1443,
1444,
14,
0,
0,
1054,
106,
1083,
1084,
284,
1085,
807,
815,
0,
263,
105,
750,
268,
1053,
1449,
819,
1451,
1452,
1453,
1454,
0,
0,
1456,
821,
0,
0,
106,
1083,
1084,
1055,
1085,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
20,
517,
1179,
1180,
0,
0,
0,
0,
0,
0,
0,
284,
0,
807,
815,
0,
0,
105,
1053,
0,
20,
0,
0,
0,
0,
0,
1414,
1415,
1054,
0,
0,
0,
0,
106,
1083,
1084,
0,
1085,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
521,
0,
1055,
597,
1056,
14,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1364,
1064,
28,
30,
1061,
31,
1065,
1341,
1342,
1343,
1344,
1345,
1346,
1347,
1348,
1349,
1350,
1351,
1352,
1353,
1354,
602,
0,
0,
0,
0,
0,
0,
0,
0,
1355,
1356,
1357,
1358,
1359,
1360,
1361,
1362,
1363,
530,
0,
0,
0,
0,
14,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
0,
20,
0,
0,
0,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
0,
533,
0,
0,
0,
1461,
1053,
832,
0,
0,
0,
1054,
0,
1055,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
1055,
20,
1056,
532,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
14,
1416,
1417,
1418,
1419,
1420,
1421,
1422,
1423,
1341,
1342,
1343,
1344,
1345,
1346,
1347,
1348,
1349,
1350,
1351,
1352,
1353,
1354,
0,
0,
0,
0,
0,
0,
0,
530,
0,
1355,
1356,
1357,
1358,
1359,
1360,
1361,
1362,
1363,
0,
14,
0,
0,
0,
0,
0,
0,
1424,
756,
1426,
0,
0,
1053,
1427,
1428,
1429,
0,
0,
0,
1054,
0,
1054,
0,
1430,
0,
533,
0,
0,
0,
0,
20,
0,
0,
0,
0,
0,
0,
759,
0,
765,
0,
0,
0,
771,
0,
777,
0,
783,
1055,
538,
1055,
0,
1056,
0,
1053,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
20,
0,
0,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
14,
0,
0,
0,
0,
0,
0,
540,
0,
0,
0,
0,
1053,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
14,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
303,
0,
0,
0,
555,
0,
0,
534,
535,
548,
0,
0,
0,
0,
0,
0,
0,
0,
0,
225,
0,
0,
0,
0,
0,
0,
14,
0,
0,
0,
1053,
0,
20,
0,
0,
106,
1083,
1084,
0,
1085,
0,
558,
1054,
0,
0,
0,
0,
0,
1450,
819,
1451,
1452,
1453,
1454,
0,
0,
20,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
557,
14,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
0,
20,
555,
14,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
14,
1064,
28,
30,
1061,
31,
1065,
1315,
535,
0,
558,
0,
303,
0,
20,
0,
0,
0,
0,
0,
836,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
225,
0,
0,
0,
0,
0,
0,
0,
0,
509,
0,
1054,
0,
0,
0,
20,
106,
1083,
1084,
0,
1085,
0,
0,
0,
0,
0,
0,
0,
0,
1449,
819,
1451,
1452,
1453,
1454,
1054,
0,
0,
14,
0,
1055,
20,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
1055,
1053,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1053,
0,
0,
0,
0,
563,
0,
0,
0,
1055,
0,
1056,
0,
20,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
0,
0,
563,
559,
560,
0,
0,
1053,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
1054,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
14,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
1053,
0,
0,
0,
563,
1054,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
14,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
563,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
530,
0,
0,
0,
1319,
560,
0,
20,
0,
14,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
0,
0,
0,
1053,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
533,
0,
20,
0,
0,
14,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
563,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
20,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
14,
0,
0,
303,
0,
0,
0,
0,
0,
0,
0,
842,
0,
530,
0,
0,
0,
0,
20,
0,
0,
0,
225,
0,
0,
14,
0,
0,
1322,
0,
0,
509,
0,
564,
0,
0,
530,
0,
106,
1083,
1084,
0,
1085,
0,
0,
0,
0,
1054,
0,
0,
533,
1449,
819,
1451,
1452,
1453,
1454,
0,
0,
0,
1323,
0,
0,
0,
0,
564,
0,
0,
0,
0,
0,
0,
20,
533,
0,
0,
1055,
0,
1056,
1054,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
20,
0,
0,
0,
0,
1324,
0,
0,
0,
0,
564,
1055,
14,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
14,
530,
0,
1325,
0,
0,
0,
0,
564,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
1054,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
533,
0,
0,
582,
535,
0,
0,
0,
0,
0,
0,
20,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
20,
0,
0,
0,
1054,
0,
0,
0,
0,
0,
1326,
0,
0,
0,
0,
564,
0,
0,
1053,
0,
0,
0,
0,
0,
0,
14,
0,
0,
0,
1054,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
590,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
1336,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
20,
0,
0,
0,
586,
535,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
14,
0,
0,
0,
530,
1053,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
0,
0,
0,
1053,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
533,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
1055,
0,
1056,
0,
1053,
34,
43,
42,
1066,
1063,
21,
40,
41,
599,
1064,
28,
30,
1061,
31,
1065,
0,
20,
0,
0,
0,
0,
0,
303,
0,
0,
0,
0,
0,
0,
1337,
847,
0,
0,
0,
0,
0,
601,
0,
0,
0,
0,
225,
0,
0,
14,
597,
0,
0,
1053,
0,
509,
0,
0,
0,
0,
0,
0,
106,
1083,
1084,
0,
1085,
0,
1054,
0,
0,
0,
14,
1053,
0,
1449,
819,
1451,
1452,
1453,
1454,
0,
0,
0,
0,
0,
0,
0,
0,
0,
617,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
14,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
633,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
20,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1053,
0,
20,
0,
0,
0,
0,
14,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
14,
0,
0,
20,
635,
1053,
0,
0,
0,
0,
639,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1340,
1064,
28,
30,
1061,
31,
1065,
1341,
1342,
1343,
1344,
1345,
1346,
1347,
1348,
1349,
1350,
1351,
1352,
1353,
1354,
0,
20,
596,
535,
0,
0,
0,
0,
0,
1355,
1356,
1357,
1358,
1359,
1360,
1361,
1362,
1363,
14,
1053,
0,
20,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
597,
0,
0,
0,
0,
0,
649,
0,
0,
0,
1054,
0,
0,
0,
0,
0,
1055,
1055,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
1054,
1055,
20,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
14,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
1054,
0,
0,
0,
0,
1053,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
656,
1064,
28,
30,
1061,
31,
1065,
1055,
20,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1340,
1064,
28,
30,
1061,
31,
1065,
1341,
1342,
1343,
1344,
1345,
1346,
1347,
1348,
1349,
1350,
1351,
1352,
1353,
1354,
0,
0,
1053,
0,
0,
0,
1054,
0,
0,
1355,
1356,
1357,
1358,
1359,
1360,
1361,
1362,
1363,
14,
0,
0,
0,
1053,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
1054,
655,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
658,
0,
0,
0,
0,
1053,
0,
0,
1055,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
64,
0,
0,
0,
0,
20,
0,
0,
0,
0,
0,
0,
0,
14,
0,
0,
656,
0,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1053,
0,
0,
14,
0,
0,
0,
673,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
64,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
53,
0,
0,
0,
0,
0,
0,
0,
14,
0,
0,
0,
0,
0,
0,
0,
0,
0,
20,
0,
673,
0,
0,
0,
0,
0,
0,
0,
0,
14,
0,
0,
0,
0,
0,
0,
1053,
0,
20,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
14,
0,
0,
1053,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
754,
1054,
677,
0,
0,
0,
14,
20,
0,
0,
0,
659,
660,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
689,
0,
20,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
677,
0,
16,
0,
0,
0,
20,
14,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
20,
0,
0,
1054,
0,
0,
0,
14,
0,
0,
0,
0,
0,
48,
0,
0,
0,
0,
1053,
0,
0,
0,
0,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1053,
1064,
28,
30,
1061,
31,
1065,
1055,
20,
1056,
793,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
14,
0,
0,
1376,
660,
0,
0,
20,
0,
0,
71,
0,
0,
0,
1054,
1385,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
14,
1055,
1054,
1056,
679,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
1054,
1383,
0,
0,
0,
14,
0,
0,
20,
1055,
51,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
690,
20,
0,
800,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
49,
0,
0,
0,
0,
0,
0,
0,
722,
0,
0,
0,
20,
0,
1054,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
1069,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
51,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1465,
1064,
28,
30,
1061,
31,
1065,
303,
0,
839,
1466,
1467,
1468,
1469,
1470,
840,
841,
0,
0,
0,
284,
0,
807,
815,
0,
0,
845,
0,
0,
0,
0,
846,
0,
0,
0,
509,
0,
0,
0,
0,
0,
0,
106,
1083,
1084,
0,
1085,
0,
0,
0,
0,
0,
0,
0,
0,
1449,
819,
1451,
1452,
1453,
1454,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
};
yyTCombType *	yyTBasePtr	[yyLastReadState + 1] = {
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [143],
& yyTComb [1],
& yyTComb [0],
& yyTComb [2],
& yyTComb [218],
& yyTComb [0],
& yyTComb [275],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [325],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1],
& yyTComb [0],
& yyTComb [3],
& yyTComb [356],
& yyTComb [0],
& yyTComb [441],
& yyTComb [0],
& yyTComb [0],
& yyTComb [472],
& yyTComb [0],
& yyTComb [507],
& yyTComb [0],
& yyTComb [225],
& yyTComb [0],
& yyTComb [0],
& yyTComb [7],
& yyTComb [416],
& yyTComb [0],
& yyTComb [538],
& yyTComb [0],
& yyTComb [546],
& yyTComb [0],
& yyTComb [582],
& yyTComb [613],
& yyTComb [648],
& yyTComb [679],
& yyTComb [710],
& yyTComb [0],
& yyTComb [744],
& yyTComb [746],
& yyTComb [9],
& yyTComb [14],
& yyTComb [0],
& yyTComb [9],
& yyTComb [6],
& yyTComb [20],
& yyTComb [103],
& yyTComb [0],
& yyTComb [18],
& yyTComb [17],
& yyTComb [0],
& yyTComb [783],
& yyTComb [13],
& yyTComb [814],
& yyTComb [56],
& yyTComb [0],
& yyTComb [29],
& yyTComb [28],
& yyTComb [0],
& yyTComb [854],
& yyTComb [51],
& yyTComb [1],
& yyTComb [0],
& yyTComb [58],
& yyTComb [0],
& yyTComb [229],
& yyTComb [0],
& yyTComb [70],
& yyTComb [72],
& yyTComb [75],
& yyTComb [906],
& yyTComb [82],
& yyTComb [93],
& yyTComb [94],
& yyTComb [104],
& yyTComb [0],
& yyTComb [102],
& yyTComb [106],
& yyTComb [108],
& yyTComb [0],
& yyTComb [0],
& yyTComb [111],
& yyTComb [112],
& yyTComb [114],
& yyTComb [112],
& yyTComb [3],
& yyTComb [0],
& yyTComb [125],
& yyTComb [0],
& yyTComb [125],
& yyTComb [0],
& yyTComb [136],
& yyTComb [0],
& yyTComb [136],
& yyTComb [1],
& yyTComb [138],
& yyTComb [0],
& yyTComb [0],
& yyTComb [905],
& yyTComb [0],
& yyTComb [156],
& yyTComb [0],
& yyTComb [2],
& yyTComb [961],
& yyTComb [31],
& yyTComb [132],
& yyTComb [0],
& yyTComb [4],
& yyTComb [0],
& yyTComb [5],
& yyTComb [6],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [140],
& yyTComb [157],
& yyTComb [1],
& yyTComb [147],
& yyTComb [158],
& yyTComb [153],
& yyTComb [167],
& yyTComb [161],
& yyTComb [162],
& yyTComb [167],
& yyTComb [165],
& yyTComb [169],
& yyTComb [176],
& yyTComb [0],
& yyTComb [176],
& yyTComb [61],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [201],
& yyTComb [230],
& yyTComb [217],
& yyTComb [300],
& yyTComb [232],
& yyTComb [0],
& yyTComb [0],
& yyTComb [222],
& yyTComb [0],
& yyTComb [222],
& yyTComb [95],
& yyTComb [0],
& yyTComb [0],
& yyTComb [261],
& yyTComb [0],
& yyTComb [266],
& yyTComb [235],
& yyTComb [238],
& yyTComb [283],
& yyTComb [240],
& yyTComb [249],
& yyTComb [251],
& yyTComb [251],
& yyTComb [261],
& yyTComb [265],
& yyTComb [267],
& yyTComb [274],
& yyTComb [280],
& yyTComb [284],
& yyTComb [279],
& yyTComb [0],
& yyTComb [280],
& yyTComb [0],
& yyTComb [289],
& yyTComb [302],
& yyTComb [312],
& yyTComb [0],
& yyTComb [412],
& yyTComb [0],
& yyTComb [303],
& yyTComb [301],
& yyTComb [326],
& yyTComb [0],
& yyTComb [0],
& yyTComb [306],
& yyTComb [381],
& yyTComb [0],
& yyTComb [0],
& yyTComb [301],
& yyTComb [345],
& yyTComb [313],
& yyTComb [314],
& yyTComb [0],
& yyTComb [346],
& yyTComb [317],
& yyTComb [329],
& yyTComb [0],
& yyTComb [354],
& yyTComb [333],
& yyTComb [350],
& yyTComb [357],
& yyTComb [350],
& yyTComb [0],
& yyTComb [324],
& yyTComb [696],
& yyTComb [354],
& yyTComb [0],
& yyTComb [0],
& yyTComb [376],
& yyTComb [366],
& yyTComb [0],
& yyTComb [421],
& yyTComb [0],
& yyTComb [413],
& yyTComb [368],
& yyTComb [417],
& yyTComb [0],
& yyTComb [372],
& yyTComb [0],
& yyTComb [387],
& yyTComb [383],
& yyTComb [0],
& yyTComb [977],
& yyTComb [851],
& yyTComb [392],
& yyTComb [0],
& yyTComb [392],
& yyTComb [394],
& yyTComb [0],
& yyTComb [412],
& yyTComb [416],
& yyTComb [0],
& yyTComb [418],
& yyTComb [431],
& yyTComb [4],
& yyTComb [431],
& yyTComb [433],
& yyTComb [442],
& yyTComb [435],
& yyTComb [437],
& yyTComb [446],
& yyTComb [439],
& yyTComb [436],
& yyTComb [0],
& yyTComb [472],
& yyTComb [434],
& yyTComb [442],
& yyTComb [480],
& yyTComb [548],
& yyTComb [553],
& yyTComb [0],
& yyTComb [443],
& yyTComb [446],
& yyTComb [0],
& yyTComb [439],
& yyTComb [214],
& yyTComb [215],
& yyTComb [360],
& yyTComb [239],
& yyTComb [838],
& yyTComb [468],
& yyTComb [0],
& yyTComb [536],
& yyTComb [477],
& yyTComb [0],
& yyTComb [492],
& yyTComb [968],
& yyTComb [487],
& yyTComb [351],
& yyTComb [502],
& yyTComb [507],
& yyTComb [1077],
& yyTComb [406],
& yyTComb [516],
& yyTComb [0],
& yyTComb [521],
& yyTComb [523],
& yyTComb [538],
& yyTComb [540],
& yyTComb [301],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [554],
& yyTComb [426],
& yyTComb [556],
& yyTComb [0],
& yyTComb [566],
& yyTComb [1225],
& yyTComb [568],
& yyTComb [574],
& yyTComb [581],
& yyTComb [578],
& yyTComb [578],
& yyTComb [0],
& yyTComb [587],
& yyTComb [468],
& yyTComb [588],
& yyTComb [604],
& yyTComb [0],
& yyTComb [1191],
& yyTComb [0],
& yyTComb [0],
& yyTComb [583],
& yyTComb [586],
& yyTComb [0],
& yyTComb [589],
& yyTComb [0],
& yyTComb [613],
& yyTComb [0],
& yyTComb [616],
& yyTComb [1086],
& yyTComb [619],
& yyTComb [617],
& yyTComb [0],
& yyTComb [642],
& yyTComb [0],
& yyTComb [0],
& yyTComb [635],
& yyTComb [0],
& yyTComb [627],
& yyTComb [668],
& yyTComb [662],
& yyTComb [661],
& yyTComb [659],
& yyTComb [1],
& yyTComb [633],
& yyTComb [673],
& yyTComb [971],
& yyTComb [684],
& yyTComb [0],
& yyTComb [0],
& yyTComb [653],
& yyTComb [0],
& yyTComb [399],
& yyTComb [0],
& yyTComb [0],
& yyTComb [640],
& yyTComb [657],
& yyTComb [665],
& yyTComb [3],
& yyTComb [691],
& yyTComb [694],
& yyTComb [677],
& yyTComb [0],
& yyTComb [758],
& yyTComb [0],
& yyTComb [681],
& yyTComb [701],
& yyTComb [0],
& yyTComb [684],
& yyTComb [0],
& yyTComb [698],
& yyTComb [0],
& yyTComb [826],
& yyTComb [693],
& yyTComb [0],
& yyTComb [699],
& yyTComb [0],
& yyTComb [715],
& yyTComb [0],
& yyTComb [719],
& yyTComb [0],
& yyTComb [738],
& yyTComb [719],
& yyTComb [742],
& yyTComb [0],
& yyTComb [723],
& yyTComb [0],
& yyTComb [725],
& yyTComb [736],
& yyTComb [0],
& yyTComb [1193],
& yyTComb [721],
& yyTComb [730],
& yyTComb [0],
& yyTComb [771],
& yyTComb [0],
& yyTComb [743],
& yyTComb [0],
& yyTComb [751],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [784],
& yyTComb [0],
& yyTComb [0],
& yyTComb [754],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [822],
& yyTComb [762],
& yyTComb [756],
& yyTComb [765],
& yyTComb [696],
& yyTComb [532],
& yyTComb [782],
& yyTComb [784],
& yyTComb [782],
& yyTComb [773],
& yyTComb [0],
& yyTComb [785],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [803],
& yyTComb [839],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [879],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [880],
& yyTComb [881],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [886],
& yyTComb [888],
& yyTComb [0],
& yyTComb [556],
& yyTComb [0],
& yyTComb [889],
& yyTComb [0],
& yyTComb [801],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [794],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [808],
& yyTComb [0],
& yyTComb [893],
& yyTComb [584],
& yyTComb [0],
& yyTComb [0],
& yyTComb [822],
& yyTComb [930],
& yyTComb [834],
& yyTComb [911],
& yyTComb [0],
& yyTComb [0],
& yyTComb [837],
& yyTComb [931],
& yyTComb [844],
& yyTComb [850],
& yyTComb [861],
& yyTComb [860],
& yyTComb [0],
& yyTComb [0],
& yyTComb [932],
& yyTComb [0],
& yyTComb [917],
& yyTComb [926],
& yyTComb [919],
& yyTComb [0],
& yyTComb [0],
& yyTComb [931],
& yyTComb [942],
& yyTComb [935],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [884],
& yyTComb [0],
& yyTComb [945],
& yyTComb [958],
& yyTComb [0],
& yyTComb [956],
& yyTComb [959],
& yyTComb [0],
& yyTComb [976],
& yyTComb [960],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [969],
& yyTComb [0],
& yyTComb [1246],
& yyTComb [0],
& yyTComb [972],
& yyTComb [0],
& yyTComb [951],
& yyTComb [0],
& yyTComb [953],
& yyTComb [958],
& yyTComb [0],
& yyTComb [1011],
& yyTComb [0],
& yyTComb [984],
& yyTComb [0],
& yyTComb [988],
& yyTComb [792],
& yyTComb [987],
& yyTComb [991],
& yyTComb [996],
& yyTComb [961],
& yyTComb [759],
& yyTComb [760],
& yyTComb [985],
& yyTComb [1387],
& yyTComb [1452],
& yyTComb [1469],
& yyTComb [0],
& yyTComb [982],
& yyTComb [1017],
& yyTComb [0],
& yyTComb [1017],
& yyTComb [961],
& yyTComb [1021],
& yyTComb [0],
& yyTComb [1022],
& yyTComb [1035],
& yyTComb [0],
& yyTComb [962],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1052],
& yyTComb [1043],
& yyTComb [0],
& yyTComb [1053],
& yyTComb [0],
& yyTComb [1054],
& yyTComb [1056],
& yyTComb [1048],
& yyTComb [1050],
& yyTComb [0],
& yyTComb [811],
& yyTComb [821],
& yyTComb [823],
& yyTComb [824],
& yyTComb [1082],
& yyTComb [0],
& yyTComb [1096],
& yyTComb [0],
& yyTComb [1066],
& yyTComb [1570],
& yyTComb [0],
& yyTComb [826],
& yyTComb [1171],
& yyTComb [1069],
& yyTComb [0],
& yyTComb [1069],
& yyTComb [1099],
& yyTComb [0],
& yyTComb [1103],
& yyTComb [1097],
& yyTComb [1102],
& yyTComb [1128],
& yyTComb [1101],
& yyTComb [1174],
& yyTComb [1101],
& yyTComb [865],
& yyTComb [1118],
& yyTComb [1119],
& yyTComb [0],
& yyTComb [1172],
& yyTComb [0],
& yyTComb [0],
& yyTComb [895],
& yyTComb [1204],
& yyTComb [1175],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1138],
& yyTComb [0],
& yyTComb [950],
& yyTComb [0],
& yyTComb [1210],
& yyTComb [1197],
& yyTComb [0],
& yyTComb [1206],
& yyTComb [0],
& yyTComb [1232],
& yyTComb [0],
& yyTComb [1212],
& yyTComb [0],
& yyTComb [1216],
& yyTComb [0],
& yyTComb [1216],
& yyTComb [1433],
& yyTComb [983],
& yyTComb [1008],
& yyTComb [1254],
& yyTComb [1253],
& yyTComb [1257],
& yyTComb [1262],
& yyTComb [0],
& yyTComb [1020],
& yyTComb [0],
& yyTComb [1286],
& yyTComb [1273],
& yyTComb [0],
& yyTComb [1274],
& yyTComb [1294],
& yyTComb [1042],
& yyTComb [1047],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1048],
& yyTComb [1055],
& yyTComb [1267],
& yyTComb [1057],
& yyTComb [1292],
& yyTComb [1301],
& yyTComb [0],
& yyTComb [1301],
& yyTComb [1244],
& yyTComb [1062],
& yyTComb [1063],
& yyTComb [1246],
& yyTComb [1248],
& yyTComb [1247],
& yyTComb [1070],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1316],
& yyTComb [0],
& yyTComb [1316],
& yyTComb [1324],
& yyTComb [0],
& yyTComb [1325],
& yyTComb [1085],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1333],
& yyTComb [0],
& yyTComb [1330],
& yyTComb [1095],
& yyTComb [1247],
& yyTComb [1252],
& yyTComb [1106],
& yyTComb [1414],
& yyTComb [1259],
& yyTComb [1260],
& yyTComb [1351],
& yyTComb [0],
& yyTComb [1355],
& yyTComb [1115],
& yyTComb [1265],
& yyTComb [1359],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1361],
& yyTComb [1404],
& yyTComb [1362],
& yyTComb [1389],
& yyTComb [1363],
& yyTComb [1407],
& yyTComb [1358],
& yyTComb [1124],
& yyTComb [1125],
& yyTComb [0],
& yyTComb [1126],
& yyTComb [1145],
& yyTComb [1413],
& yyTComb [1196],
& yyTComb [1147],
& yyTComb [1199],
& yyTComb [1406],
& yyTComb [0],
& yyTComb [1422],
& yyTComb [1342],
& yyTComb [1377],
& yyTComb [1317],
& yyTComb [1422],
& yyTComb [0],
& yyTComb [1447],
& yyTComb [1408],
& yyTComb [1442],
& yyTComb [0],
& yyTComb [1442],
& yyTComb [0],
& yyTComb [1443],
& yyTComb [1451],
& yyTComb [1446],
& yyTComb [0],
& yyTComb [1455],
& yyTComb [1457],
& yyTComb [0],
& yyTComb [1464],
& yyTComb [1463],
& yyTComb [1458],
& yyTComb [1322],
& yyTComb [0],
& yyTComb [1462],
& yyTComb [1468],
& yyTComb [1457],
& yyTComb [0],
& yyTComb [1464],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1466],
& yyTComb [1488],
& yyTComb [1335],
& yyTComb [1468],
& yyTComb [0],
& yyTComb [1479],
& yyTComb [0],
& yyTComb [1290],
& yyTComb [1341],
& yyTComb [1523],
& yyTComb [0],
& yyTComb [1524],
& yyTComb [0],
& yyTComb [1492],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1533],
& yyTComb [1539],
& yyTComb [1496],
& yyTComb [1498],
& yyTComb [1508],
& yyTComb [0],
& yyTComb [1518],
& yyTComb [0],
& yyTComb [1524],
& yyTComb [0],
& yyTComb [1546],
& yyTComb [0],
& yyTComb [1529],
& yyTComb [1543],
& yyTComb [0],
& yyTComb [1555],
& yyTComb [1549],
& yyTComb [1543],
& yyTComb [1573],
& yyTComb [0],
& yyTComb [1588],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1537],
& yyTComb [1306],
& yyTComb [1557],
& yyTComb [1571],
& yyTComb [1424],
& yyTComb [1574],
& yyTComb [1429],
& yyTComb [1594],
& yyTComb [1527],
& yyTComb [1587],
& yyTComb [0],
& yyTComb [1589],
& yyTComb [1533],
& yyTComb [1550],
& yyTComb [1588],
& yyTComb [1565],
& yyTComb [1421],
& yyTComb [1355],
& yyTComb [0],
& yyTComb [1404],
& yyTComb [1458],
& yyTComb [0],
& yyTComb [1423],
& yyTComb [1367],
& yyTComb [0],
& yyTComb [1415],
& yyTComb [1462],
& yyTComb [0],
& yyTComb [1425],
& yyTComb [1373],
& yyTComb [0],
& yyTComb [1418],
& yyTComb [1463],
& yyTComb [0],
& yyTComb [1429],
& yyTComb [1381],
& yyTComb [0],
& yyTComb [1426],
& yyTComb [1470],
& yyTComb [1750],
& yyTComb [1428],
& yyTComb [1386],
& yyTComb [1611],
& yyTComb [1431],
& yyTComb [1465],
& yyTComb [1604],
& yyTComb [1430],
& yyTComb [1616],
& yyTComb [1674],
& yyTComb [0],
& yyTComb [1681],
& yyTComb [1442],
& yyTComb [0],
& yyTComb [1623],
& yyTComb [1444],
& yyTComb [1690],
& yyTComb [0],
& yyTComb [1446],
& yyTComb [1660],
& yyTComb [1633],
& yyTComb [1457],
& yyTComb [1646],
& yyTComb [1460],
& yyTComb [1676],
& yyTComb [1654],
& yyTComb [0],
& yyTComb [1703],
& yyTComb [1467],
& yyTComb [0],
& yyTComb [1646],
& yyTComb [1649],
& yyTComb [1473],
& yyTComb [0],
& yyTComb [1664],
& yyTComb [1474],
& yyTComb [1477],
& yyTComb [1481],
& yyTComb [0],
& yyTComb [1669],
& yyTComb [1670],
& yyTComb [1671],
& yyTComb [0],
& yyTComb [1615],
& yyTComb [0],
& yyTComb [1489],
& yyTComb [1725],
& yyTComb [0],
& yyTComb [1614],
& yyTComb [1615],
& yyTComb [1619],
& yyTComb [1812],
& yyTComb [1495],
& yyTComb [0],
& yyTComb [1620],
& yyTComb [1500],
& yyTComb [1501],
& yyTComb [0],
& yyTComb [1757],
& yyTComb [0],
& yyTComb [1711],
& yyTComb [1503],
& yyTComb [1504],
& yyTComb [1749],
& yyTComb [1977],
& yyTComb [1715],
& yyTComb [1522],
& yyTComb [1524],
& yyTComb [1780],
};
unsigned short*	yyNBasePtr	[yyLastReadState + 1] = {
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-255],
& yyNComb [-254],
& yyNComb [-255],
& yyNComb [-250],
& yyNComb [-252],
& yyNComb [-256],
& yyNComb [-249],
& yyNComb [-256],
& yyNComb [-229],
& yyNComb [-207],
& yyNComb [-179],
& yyNComb [-158],
& yyNComb [-256],
& yyNComb [-101],
& yyNComb [-256],
& yyNComb [-126],
& yyNComb [-256],
& yyNComb [-51],
& yyNComb [-77],
& yyNComb [-254],
& yyNComb [-28],
& yyNComb [-256],
& yyNComb [9],
& yyNComb [33],
& yyNComb [-256],
& yyNComb [-152],
& yyNComb [-256],
& yyNComb [39],
& yyNComb [-73],
& yyNComb [-256],
& yyNComb [167],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [61],
& yyNComb [-256],
& yyNComb [134],
& yyNComb [-253],
& yyNComb [252],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-253],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [280],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [330],
& yyNComb [-256],
& yyNComb [362],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [424],
& yyNComb [450],
& yyNComb [-256],
& yyNComb [-252],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [525],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [549],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [492],
& yyNComb [-256],
& yyNComb [612],
& yyNComb [-256],
& yyNComb [639],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [715],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-252],
& yyNComb [742],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-251],
& yyNComb [-255],
& yyNComb [-239],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-236],
& yyNComb [-237],
& yyNComb [-214],
& yyNComb [-256],
& yyNComb [-233],
& yyNComb [-256],
& yyNComb [-209],
& yyNComb [-256],
& yyNComb [-189],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-200],
& yyNComb [-170],
& yyNComb [-255],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-230],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-246],
& yyNComb [-256],
& yyNComb [-232],
& yyNComb [-227],
& yyNComb [-256],
& yyNComb [-226],
& yyNComb [-224],
& yyNComb [-178],
& yyNComb [-241],
& yyNComb [871],
& yyNComb [-243],
& yyNComb [-229],
& yyNComb [808],
& yyNComb [-198],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [948],
& yyNComb [-256],
& yyNComb [-242],
& yyNComb [-256],
& yyNComb [1001],
& yyNComb [-229],
& yyNComb [808],
& yyNComb [-225],
& yyNComb [-189],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-186],
& yyNComb [-224],
& yyNComb [-256],
& yyNComb [1024],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1078],
& yyNComb [-255],
& yyNComb [-256],
& yyNComb [-184],
& yyNComb [-179],
& yyNComb [-256],
& yyNComb [-183],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-177],
& yyNComb [-173],
& yyNComb [-155],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1098],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1140],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-125],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-122],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1161],
& yyNComb [-256],
& yyNComb [-76],
& yyNComb [-256],
& yyNComb [-69],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-255],
& yyNComb [-256],
& yyNComb [-254],
& yyNComb [-256],
& yyNComb [-222],
& yyNComb [-221],
& yyNComb [-256],
& yyNComb [1226],
& yyNComb [-256],
& yyNComb [-255],
& yyNComb [-248],
& yyNComb [-248],
& yyNComb [-246],
& yyNComb [-184],
& yyNComb [-232],
& yyNComb [-256],
& yyNComb [-141],
& yyNComb [-167],
& yyNComb [-195],
& yyNComb [-256],
& yyNComb [-136],
& yyNComb [-149],
& yyNComb [-256],
& yyNComb [-147],
& yyNComb [-143],
& yyNComb [-256],
& yyNComb [-82],
& yyNComb [-132],
& yyNComb [-248],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-251],
& yyNComb [-228],
& yyNComb [-134],
& yyNComb [1356],
& yyNComb [-256],
& yyNComb [1294],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1424],
& yyNComb [-256],
& yyNComb [1456],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-128],
& yyNComb [-232],
& yyNComb [-213],
& yyNComb [-256],
& yyNComb [1498],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-231],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1553],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-208],
& yyNComb [-71],
& yyNComb [-202],
& yyNComb [1617],
& yyNComb [-256],
& yyNComb [-202],
& yyNComb [-159],
& yyNComb [-201],
& yyNComb [1525],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-66],
& yyNComb [-256],
& yyNComb [-218],
& yyNComb [-215],
& yyNComb [-256],
& yyNComb [-112],
& yyNComb [1867],
& yyNComb [-256],
& yyNComb [-51],
& yyNComb [-198],
& yyNComb [-256],
& yyNComb [179],
& yyNComb [-256],
& yyNComb [-244],
& yyNComb [-249],
& yyNComb [-155],
& yyNComb [-202],
& yyNComb [-256],
& yyNComb [-254],
& yyNComb [-68],
& yyNComb [-256],
& yyNComb [277],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-113],
& yyNComb [413],
& yyNComb [1221],
& yyNComb [-113],
& yyNComb [-212],
& yyNComb [-96],
& yyNComb [-256],
& yyNComb [44],
& yyNComb [-256],
& yyNComb [372],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-109],
& yyNComb [-256],
& yyNComb [206],
& yyNComb [-256],
& yyNComb [-210],
& yyNComb [-96],
& yyNComb [1912],
& yyNComb [353],
& yyNComb [417],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [437],
& yyNComb [-256],
& yyNComb [547],
& yyNComb [-256],
& yyNComb [1719],
& yyNComb [-256],
& yyNComb [-107],
& yyNComb [428],
& yyNComb [-256],
& yyNComb [201],
& yyNComb [-256],
& yyNComb [377],
& yyNComb [1834],
& yyNComb [-256],
& yyNComb [1911],
& yyNComb [-256],
& yyNComb [-199],
& yyNComb [-245],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [460],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [472],
& yyNComb [-256],
& yyNComb [545],
& yyNComb [220],
& yyNComb [-256],
& yyNComb [236],
& yyNComb [-106],
& yyNComb [-53],
& yyNComb [-98],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [202],
& yyNComb [424],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-47],
& yyNComb [-256],
& yyNComb [-97],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [176],
& yyNComb [-256],
& yyNComb [254],
& yyNComb [-256],
& yyNComb [-203],
& yyNComb [519],
& yyNComb [-202],
& yyNComb [25],
& yyNComb [-256],
& yyNComb [259],
& yyNComb [-256],
& yyNComb [184],
& yyNComb [-256],
& yyNComb [2019],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [347],
& yyNComb [-77],
& yyNComb [-75],
& yyNComb [-125],
& yyNComb [-256],
& yyNComb [434],
& yyNComb [-168],
& yyNComb [-79],
& yyNComb [-256],
& yyNComb [-48],
& yyNComb [-123],
& yyNComb [-74],
& yyNComb [-43],
& yyNComb [208],
& yyNComb [-166],
& yyNComb [-79],
& yyNComb [315],
& yyNComb [279],
& yyNComb [328],
& yyNComb [323],
& yyNComb [-154],
& yyNComb [329],
& yyNComb [-256],
& yyNComb [548],
& yyNComb [-160],
& yyNComb [598],
& yyNComb [-155],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-149],
& yyNComb [-243],
& yyNComb [-225],
& yyNComb [-256],
& yyNComb [-148],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [418],
& yyNComb [-256],
& yyNComb [435],
& yyNComb [-55],
& yyNComb [373],
& yyNComb [-94],
& yyNComb [-256],
& yyNComb [451],
& yyNComb [-49],
& yyNComb [455],
& yyNComb [-256],
& yyNComb [457],
& yyNComb [-48],
& yyNComb [521],
& yyNComb [-89],
& yyNComb [-256],
& yyNComb [589],
& yyNComb [-43],
& yyNComb [614],
& yyNComb [-53],
& yyNComb [-256],
& yyNComb [654],
& yyNComb [2],
& yyNComb [532],
& yyNComb [-256],
& yyNComb [544],
& yyNComb [21],
& yyNComb [610],
& yyNComb [-93],
& yyNComb [29],
& yyNComb [-256],
& yyNComb [133],
& yyNComb [172],
& yyNComb [351],
& yyNComb [336],
& yyNComb [-90],
& yyNComb [375],
& yyNComb [339],
& yyNComb [85],
& yyNComb [269],
& yyNComb [158],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [570],
& yyNComb [185],
& yyNComb [622],
& yyNComb [245],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [651],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [258],
& yyNComb [619],
& yyNComb [-256],
& yyNComb [684],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [280],
& yyNComb [736],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [300],
& yyNComb [805],
& yyNComb [620],
& yyNComb [-256],
& yyNComb [2039],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [730],
& yyNComb [720],
& yyNComb [-256],
& yyNComb [726],
& yyNComb [609],
& yyNComb [-256],
& yyNComb [637],
& yyNComb [301],
& yyNComb [583],
& yyNComb [-256],
& yyNComb [734],
& yyNComb [303],
& yyNComb [737],
& yyNComb [-256],
& yyNComb [740],
& yyNComb [314],
& yyNComb [707],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [552],
& yyNComb [-256],
& yyNComb [806],
& yyNComb [-256],
& yyNComb [763],
& yyNComb [-256],
& yyNComb [446],
& yyNComb [-256],
& yyNComb [792],
& yyNComb [-256],
& yyNComb [300],
& yyNComb [336],
& yyNComb [340],
& yyNComb [903],
& yyNComb [2149],
& yyNComb [57],
& yyNComb [393],
& yyNComb [572],
& yyNComb [2149],
& yyNComb [-256],
& yyNComb [2151],
& yyNComb [-256],
& yyNComb [2012],
& yyNComb [-256],
& yyNComb [2205],
& yyNComb [-256],
& yyNComb [2012],
& yyNComb [103],
& yyNComb [-256],
& yyNComb [407],
& yyNComb [419],
& yyNComb [-256],
& yyNComb [2296],
& yyNComb [163],
& yyNComb [-256],
& yyNComb [2338],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [2422],
& yyNComb [2446],
& yyNComb [-256],
& yyNComb [2488],
& yyNComb [-256],
& yyNComb [580],
& yyNComb [200],
& yyNComb [-256],
& yyNComb [233],
& yyNComb [-256],
& yyNComb [429],
& yyNComb [2530],
& yyNComb [-256],
& yyNComb [478],
& yyNComb [-256],
& yyNComb [374],
& yyNComb [-256],
& yyNComb [751],
& yyNComb [2562],
& yyNComb [-256],
& yyNComb [2588],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [2657],
& yyNComb [2780],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [2812],
& yyNComb [-256],
& yyNComb [2854],
& yyNComb [186],
& yyNComb [2887],
& yyNComb [859],
& yyNComb [-256],
& yyNComb [2966],
& yyNComb [212],
& yyNComb [244],
& yyNComb [266],
& yyNComb [850],
& yyNComb [-256],
& yyNComb [1022],
& yyNComb [1028],
& yyNComb [-256],
& yyNComb [2941],
& yyNComb [-256],
& yyNComb [3050],
& yyNComb [-256],
& yyNComb [3073],
& yyNComb [-256],
& yyNComb [3170],
& yyNComb [-256],
& yyNComb [3259],
& yyNComb [-256],
& yyNComb [3360],
& yyNComb [554],
& yyNComb [561],
& yyNComb [-256],
& yyNComb [3359],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [3382],
& yyNComb [-256],
& yyNComb [3410],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [301],
& yyNComb [-256],
& yyNComb [380],
& yyNComb [818],
& yyNComb [649],
& yyNComb [858],
& yyNComb [349],
& yyNComb [821],
& yyNComb [662],
& yyNComb [938],
& yyNComb [691],
& yyNComb [945],
& yyNComb [-256],
& yyNComb [3459],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [906],
& yyNComb [693],
& yyNComb [954],
& yyNComb [409],
& yyNComb [-256],
& yyNComb [939],
& yyNComb [719],
& yyNComb [707],
& yyNComb [709],
& yyNComb [-256],
& yyNComb [733],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [3479],
& yyNComb [-256],
& yyNComb [3580],
& yyNComb [967],
& yyNComb [433],
& yyNComb [745],
& yyNComb [3548],
& yyNComb [-256],
& yyNComb [754],
& yyNComb [988],
& yyNComb [450],
& yyNComb [810],
& yyNComb [989],
& yyNComb [998],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [3645],
& yyNComb [-256],
& yyNComb [855],
& yyNComb [692],
& yyNComb [566],
& yyNComb [3768],
& yyNComb [3848],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [3868],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [3910],
& yyNComb [1006],
& yyNComb [887],
& yyNComb [1026],
& yyNComb [1007],
& yyNComb [896],
& yyNComb [1029],
& yyNComb [-256],
& yyNComb [1008],
& yyNComb [703],
& yyNComb [-256],
& yyNComb [3931],
& yyNComb [668],
& yyNComb [1074],
& yyNComb [1075],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [3961],
& yyNComb [596],
& yyNComb [3981],
& yyNComb [-256],
& yyNComb [905],
& yyNComb [-256],
& yyNComb [1131],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [4060],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1476],
& yyNComb [1069],
& yyNComb [972],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [919],
& yyNComb [922],
& yyNComb [613],
& yyNComb [-256],
& yyNComb [1017],
& yyNComb [-256],
& yyNComb [1071],
& yyNComb [1237],
& yyNComb [795],
& yyNComb [737],
& yyNComb [810],
& yyNComb [-256],
& yyNComb [1087],
& yyNComb [-256],
& yyNComb [1113],
& yyNComb [1014],
& yyNComb [804],
& yyNComb [694],
& yyNComb [1486],
& yyNComb [-256],
& yyNComb [1526],
& yyNComb [-256],
& yyNComb [726],
& yyNComb [1027],
& yyNComb [-256],
& yyNComb [4125],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1076],
& yyNComb [-256],
& yyNComb [1027],
& yyNComb [-256],
& yyNComb [1319],
& yyNComb [-256],
& yyNComb [1381],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1518],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1579],
& yyNComb [-256],
& yyNComb [1041],
& yyNComb [1103],
& yyNComb [1104],
& yyNComb [1033],
& yyNComb [737],
& yyNComb [-256],
& yyNComb [770],
& yyNComb [-256],
& yyNComb [737],
& yyNComb [-256],
& yyNComb [870],
& yyNComb [-256],
& yyNComb [4034],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1163],
& yyNComb [-256],
& yyNComb [748],
& yyNComb [1046],
& yyNComb [1050],
& yyNComb [1280],
& yyNComb [-256],
& yyNComb [748],
& yyNComb [1106],
& yyNComb [1096],
& yyNComb [1097],
& yyNComb [1366],
& yyNComb [-256],
& yyNComb [782],
& yyNComb [1113],
& yyNComb [1109],
& yyNComb [1110],
& yyNComb [1468],
& yyNComb [-256],
& yyNComb [782],
& yyNComb [1119],
& yyNComb [1114],
& yyNComb [1120],
& yyNComb [1491],
& yyNComb [-256],
& yyNComb [791],
& yyNComb [1164],
& yyNComb [-256],
& yyNComb [1127],
& yyNComb [1503],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1127],
& yyNComb [1138],
& yyNComb [-256],
& yyNComb [4167],
& yyNComb [-256],
& yyNComb [1129],
& yyNComb [1510],
& yyNComb [-256],
& yyNComb [1162],
& yyNComb [-256],
& yyNComb [4194],
& yyNComb [1130],
& yyNComb [1536],
& yyNComb [-256],
& yyNComb [1166],
& yyNComb [1096],
& yyNComb [1134],
& yyNComb [1986],
& yyNComb [-256],
& yyNComb [1136],
& yyNComb [1150],
& yyNComb [1174],
& yyNComb [1182],
& yyNComb [1169],
& yyNComb [1163],
& yyNComb [1190],
& yyNComb [2100],
& yyNComb [1169],
& yyNComb [1199],
& yyNComb [1201],
& yyNComb [1202],
& yyNComb [2554],
& yyNComb [2125],
& yyNComb [1198],
& yyNComb [-256],
& yyNComb [1046],
& yyNComb [-256],
& yyNComb [1235],
& yyNComb [1208],
& yyNComb [-256],
& yyNComb [1237],
& yyNComb [-256],
& yyNComb [1083],
& yyNComb [2181],
& yyNComb [1217],
& yyNComb [1225],
& yyNComb [2692],
& yyNComb [1212],
& yyNComb [1234],
& yyNComb [1242],
& yyNComb [4543],
& yyNComb [1247],
& yyNComb [3036],
& yyNComb [1231],
& yyNComb [1250],
& yyNComb [1252],
& yyNComb [1699],
& yyNComb [3429],
& yyNComb [1225],
& yyNComb [1255],
& yyNComb [1257],
& yyNComb [-256],
};
unsigned short	yyDefault	[yyLastReadState + 1] = {
0,
0,
5,
846,
833,
840,
0,
344,
680,
318,
680,
25,
721,
25,
736,
721,
555,
680,
673,
680,
25,
46,
20,
40,
25,
30,
61,
25,
0,
25,
833,
0,
680,
673,
47,
680,
43,
680,
42,
680,
0,
61,
0,
0,
61,
20,
0,
0,
53,
0,
721,
0,
56,
673,
0,
56,
680,
0,
833,
61,
0,
0,
673,
680,
67,
323,
680,
0,
321,
0,
680,
321,
680,
673,
680,
673,
0,
0,
0,
680,
0,
673,
673,
251,
680,
673,
0,
833,
809,
92,
0,
0,
833,
0,
806,
0,
833,
0,
806,
0,
833,
110,
0,
0,
806,
806,
345,
0,
0,
100,
0,
95,
0,
0,
833,
0,
274,
0,
0,
262,
372,
248,
130,
125,
134,
130,
0,
0,
680,
0,
0,
0,
680,
125,
680,
202,
693,
0,
0,
697,
202,
146,
145,
0,
0,
721,
0,
0,
693,
697,
0,
693,
0,
0,
697,
697,
271,
207,
0,
680,
673,
0,
680,
673,
0,
833,
736,
0,
833,
736,
0,
680,
321,
833,
736,
833,
736,
0,
0,
207,
0,
207,
0,
202,
202,
188,
721,
0,
0,
705,
706,
704,
833,
372,
0,
833,
833,
372,
0,
833,
202,
0,
0,
833,
0,
833,
833,
0,
0,
272,
211,
272,
833,
680,
673,
680,
673,
0,
0,
680,
0,
680,
0,
0,
833,
245,
112,
0,
248,
0,
0,
402,
0,
0,
248,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
833,
265,
132,
0,
0,
0,
0,
680,
321,
0,
833,
0,
0,
0,
0,
833,
357,
0,
202,
0,
0,
202,
0,
0,
0,
705,
0,
0,
0,
833,
0,
291,
0,
0,
0,
0,
0,
832,
846,
833,
0,
833,
0,
299,
0,
0,
0,
0,
0,
0,
300,
833,
0,
833,
0,
0,
833,
0,
315,
315,
736,
0,
315,
0,
315,
0,
680,
0,
549,
833,
0,
331,
326,
328,
680,
0,
680,
673,
325,
0,
0,
0,
331,
0,
0,
833,
0,
315,
833,
0,
833,
449,
342,
833,
0,
0,
833,
357,
0,
0,
0,
833,
0,
833,
0,
0,
833,
0,
833,
0,
358,
0,
0,
833,
0,
833,
0,
833,
0,
680,
673,
0,
0,
833,
488,
833,
0,
0,
833,
0,
833,
0,
833,
372,
388,
833,
388,
0,
833,
833,
388,
833,
0,
398,
833,
736,
833,
395,
833,
736,
0,
0,
0,
0,
399,
0,
0,
0,
0,
833,
0,
833,
488,
833,
372,
0,
833,
488,
833,
0,
833,
488,
833,
372,
0,
833,
488,
833,
372,
0,
833,
431,
299,
0,
299,
488,
299,
440,
833,
0,
833,
442,
381,
442,
0,
833,
388,
449,
448,
833,
0,
0,
833,
488,
454,
833,
0,
0,
833,
0,
0,
0,
488,
833,
0,
833,
0,
0,
0,
488,
833,
0,
0,
0,
488,
833,
833,
0,
680,
321,
0,
833,
833,
0,
833,
833,
0,
833,
488,
833,
0,
833,
0,
833,
0,
833,
833,
504,
0,
0,
833,
0,
833,
0,
504,
0,
0,
0,
502,
0,
0,
833,
0,
782,
591,
0,
0,
801,
510,
0,
680,
673,
522,
0,
680,
673,
591,
605,
0,
833,
833,
0,
595,
605,
555,
680,
673,
673,
0,
0,
595,
680,
601,
680,
601,
833,
605,
0,
605,
0,
0,
680,
601,
0,
0,
605,
0,
570,
561,
64,
680,
673,
673,
0,
0,
680,
680,
321,
0,
680,
0,
680,
575,
680,
833,
0,
680,
575,
575,
0,
579,
736,
579,
833,
0,
595,
0,
595,
0,
595,
0,
595,
0,
680,
673,
833,
833,
833,
0,
680,
0,
736,
680,
601,
680,
0,
0,
605,
0,
0,
833,
0,
621,
622,
833,
0,
782,
0,
644,
0,
680,
673,
0,
833,
0,
612,
0,
0,
833,
833,
812,
813,
0,
833,
0,
0,
680,
673,
591,
641,
642,
0,
680,
673,
0,
645,
0,
0,
782,
782,
0,
0,
680,
673,
0,
0,
0,
661,
680,
673,
673,
680,
673,
0,
0,
680,
833,
0,
667,
833,
0,
782,
0,
833,
651,
0,
680,
0,
833,
782,
0,
0,
721,
0,
20,
0,
833,
0,
833,
736,
0,
0,
680,
673,
0,
833,
202,
202,
0,
0,
697,
202,
0,
0,
202,
0,
202,
156,
0,
0,
0,
0,
202,
0,
202,
743,
747,
0,
833,
736,
833,
0,
745,
833,
0,
680,
0,
0,
0,
833,
736,
743,
0,
833,
736,
833,
0,
0,
833,
0,
0,
0,
0,
833,
0,
743,
743,
0,
0,
0,
0,
749,
0,
0,
0,
758,
0,
680,
673,
0,
833,
0,
0,
0,
0,
785,
0,
0,
782,
0,
0,
785,
0,
0,
782,
0,
0,
785,
0,
0,
782,
0,
0,
785,
0,
0,
0,
0,
0,
782,
0,
0,
0,
833,
833,
0,
680,
673,
0,
801,
0,
833,
0,
680,
0,
782,
0,
833,
0,
0,
357,
0,
833,
0,
0,
833,
809,
0,
0,
846,
0,
833,
0,
0,
846,
806,
0,
0,
831,
0,
833,
0,
0,
833,
0,
0,
806,
0,
0,
846,
0,
833,
0,
3,
1,
846,
0,
833,
0,
225,
357,
0,
833,
0,
0,
};
unsigned char	yyLength	[yyLastReduceState - yyFirstReduceState + 1] = {
2,
2,
2,
0,
2,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
0,
1,
0,
1,
0,
0,
1,
1,
2,
1,
1,
1,
1,
1,
2,
4,
4,
2,
1,
0,
6,
2,
1,
0,
4,
5,
2,
1,
0,
4,
2,
1,
0,
6,
0,
4,
0,
2,
2,
2,
5,
1,
1,
1,
3,
3,
1,
1,
4,
3,
2,
2,
1,
0,
0,
2,
3,
1,
3,
1,
1,
5,
0,
3,
1,
2,
1,
1,
3,
5,
3,
5,
1,
1,
1,
1,
1,
3,
1,
1,
1,
3,
2,
2,
1,
1,
1,
4,
3,
1,
1,
1,
3,
2,
3,
0,
1,
1,
3,
2,
4,
1,
3,
1,
3,
0,
1,
1,
1,
1,
2,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
3,
4,
0,
3,
0,
2,
0,
2,
3,
1,
1,
1,
3,
0,
1,
2,
2,
3,
1,
1,
1,
4,
4,
4,
1,
1,
1,
4,
4,
4,
1,
1,
1,
1,
1,
1,
1,
3,
1,
3,
2,
2,
1,
3,
6,
0,
3,
4,
4,
1,
2,
0,
3,
4,
3,
2,
1,
0,
3,
6,
0,
3,
3,
1,
3,
1,
1,
2,
3,
0,
3,
4,
4,
1,
3,
1,
3,
2,
1,
3,
1,
2,
1,
3,
1,
1,
1,
3,
3,
1,
3,
1,
4,
4,
3,
1,
3,
1,
6,
6,
6,
1,
3,
1,
4,
0,
3,
4,
3,
1,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
3,
1,
3,
1,
2,
3,
1,
3,
1,
2,
3,
1,
3,
1,
2,
2,
1,
3,
4,
1,
3,
1,
5,
3,
3,
1,
3,
1,
1,
3,
3,
1,
1,
4,
1,
3,
3,
8,
0,
1,
0,
1,
3,
0,
2,
2,
2,
0,
2,
2,
2,
6,
0,
2,
1,
1,
0,
2,
4,
1,
3,
1,
0,
1,
4,
4,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
6,
1,
1,
1,
1,
3,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
2,
1,
3,
1,
2,
2,
1,
3,
1,
2,
2,
1,
3,
4,
1,
3,
3,
1,
2,
1,
3,
3,
3,
1,
3,
1,
3,
1,
3,
1,
5,
6,
1,
3,
1,
1,
3,
1,
1,
1,
3,
1,
1,
1,
1,
1,
1,
1,
2,
1,
3,
1,
2,
1,
3,
1,
2,
1,
3,
1,
3,
2,
0,
2,
3,
2,
6,
3,
1,
3,
1,
1,
1,
2,
3,
0,
3,
1,
3,
1,
1,
2,
1,
3,
1,
2,
3,
0,
1,
3,
4,
2,
0,
3,
3,
4,
1,
1,
3,
1,
4,
3,
1,
4,
3,
4,
3,
4,
8,
3,
3,
1,
1,
3,
1,
3,
2,
1,
3,
2,
2,
5,
2,
2,
1,
1,
1,
1,
1,
1,
1,
2,
4,
2,
3,
0,
3,
0,
1,
2,
2,
2,
1,
1,
1,
1,
1,
1,
1,
3,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
2,
3,
0,
4,
1,
3,
6,
3,
3,
4,
1,
2,
1,
1,
2,
2,
1,
2,
1,
4,
3,
4,
3,
4,
6,
3,
5,
1,
1,
1,
2,
4,
5,
1,
3,
3,
1,
2,
1,
1,
1,
1,
1,
1,
1,
1,
1,
2,
3,
2,
4,
2,
4,
2,
3,
2,
2,
2,
2,
2,
2,
2,
2,
2,
1,
1,
3,
1,
3,
1,
3,
1,
3,
1,
1,
1,
1,
1,
3,
1,
2,
2,
1,
4,
1,
2,
1,
3,
11,
10,
3,
0,
4,
3,
3,
3,
4,
1,
3,
4,
1,
3,
1,
1,
6,
0,
1,
1,
3,
5,
3,
5,
4,
2,
2,
4,
9,
5,
3,
1,
11,
0,
9,
4,
5,
8,
0,
7,
3,
8,
1,
2,
5,
5,
3,
1,
3,
1,
2,
2,
3,
3,
4,
2,
5,
1,
3,
1,
4,
4,
2,
1,
1,
3,
1,
3,
6,
2,
4,
4,
6,
4,
3,
6,
0,
1,
3,
6,
1,
0,
1,
2,
0,
3,
1,
3,
3,
6,
1,
0,
1,
3,
6,
1,
0,
1,
6,
1,
0,
1,
1,
1,
3,
3,
4,
1,
3,
1,
3,
1,
3,
5,
3,
0,
1,
3,
5,
3,
3,
3,
1,
1,
1,
3,
1,
1,
1,
3,
1,
1,
1,
3,
1,
1,
2,
1,
1,
3,
1,
1,
1,
1,
1,
1,
1,
3,
1,
1,
3,
2,
2,
1,
1,
1,
2,
1,
3,
1,
1,
1,
3,
1,
2,
1,
1,
1,
1,
3,
4,
1,
1,
1,
5,
2,
1,
1,
1,
1,
1,
1,
2,
2,
2,
};
yySymbolRange	yyLeftHandSide	[yyLastReduceState - yyFirstReduceState + 1] = {
613,
258,
259,
256,
256,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
261,
261,
262,
262,
263,
263,
264,
265,
265,
257,
257,
266,
266,
266,
266,
266,
267,
267,
273,
274,
274,
274,
271,
276,
276,
276,
268,
277,
278,
278,
278,
269,
281,
281,
281,
280,
282,
282,
279,
279,
279,
279,
279,
284,
284,
286,
286,
287,
287,
285,
270,
288,
288,
289,
289,
289,
275,
275,
275,
290,
290,
291,
291,
272,
294,
294,
295,
295,
296,
296,
298,
298,
298,
298,
299,
299,
299,
299,
300,
300,
300,
300,
301,
301,
303,
303,
283,
283,
283,
283,
305,
304,
304,
307,
307,
308,
308,
309,
306,
306,
306,
311,
311,
310,
310,
292,
312,
312,
313,
313,
313,
313,
313,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
342,
342,
341,
343,
343,
344,
344,
345,
345,
302,
302,
346,
346,
317,
347,
347,
347,
348,
348,
349,
349,
349,
349,
349,
349,
349,
349,
349,
349,
349,
349,
349,
349,
349,
349,
350,
350,
350,
326,
352,
352,
353,
327,
354,
354,
355,
357,
357,
323,
323,
359,
359,
360,
360,
360,
361,
358,
358,
358,
314,
314,
362,
362,
364,
363,
363,
365,
365,
320,
320,
368,
368,
367,
367,
369,
369,
370,
370,
328,
371,
371,
372,
330,
373,
373,
374,
321,
321,
321,
321,
375,
375,
366,
366,
366,
332,
377,
377,
378,
338,
338,
338,
379,
379,
380,
331,
383,
383,
383,
381,
382,
334,
334,
384,
384,
385,
385,
335,
335,
386,
386,
387,
387,
336,
336,
388,
388,
389,
389,
322,
390,
390,
391,
391,
337,
392,
392,
393,
393,
333,
394,
394,
395,
395,
324,
396,
396,
397,
398,
398,
400,
400,
401,
401,
399,
399,
404,
404,
404,
404,
406,
406,
319,
407,
407,
408,
315,
412,
412,
409,
409,
409,
411,
411,
413,
413,
410,
410,
414,
414,
316,
416,
416,
418,
418,
417,
417,
419,
420,
420,
421,
415,
415,
415,
415,
376,
376,
422,
422,
422,
422,
422,
422,
422,
422,
422,
329,
351,
351,
351,
432,
432,
433,
339,
339,
339,
339,
339,
339,
339,
339,
339,
340,
340,
340,
340,
340,
434,
448,
448,
449,
449,
435,
450,
450,
451,
451,
442,
452,
452,
453,
454,
454,
455,
455,
443,
456,
456,
457,
445,
458,
458,
459,
446,
460,
460,
461,
447,
447,
463,
463,
464,
462,
462,
465,
465,
466,
466,
467,
467,
467,
467,
467,
467,
467,
444,
468,
468,
469,
444,
470,
470,
471,
440,
472,
472,
473,
441,
474,
476,
476,
475,
436,
478,
478,
479,
479,
481,
481,
481,
480,
480,
482,
482,
483,
483,
484,
484,
438,
486,
486,
487,
437,
488,
490,
490,
491,
491,
491,
492,
492,
489,
489,
489,
477,
477,
494,
494,
494,
494,
494,
494,
494,
494,
494,
494,
494,
494,
494,
494,
439,
496,
496,
497,
495,
495,
498,
499,
499,
498,
500,
500,
498,
498,
498,
498,
498,
498,
498,
498,
498,
293,
293,
502,
502,
503,
503,
503,
501,
504,
504,
504,
504,
504,
509,
509,
509,
505,
505,
505,
505,
505,
505,
505,
505,
505,
505,
505,
505,
505,
505,
526,
519,
519,
527,
527,
528,
528,
519,
513,
513,
513,
524,
524,
515,
523,
523,
518,
518,
518,
516,
512,
512,
517,
517,
522,
506,
532,
532,
531,
533,
534,
514,
514,
514,
529,
529,
530,
530,
530,
521,
521,
521,
521,
521,
521,
521,
521,
521,
537,
537,
535,
535,
536,
536,
536,
536,
538,
539,
540,
540,
541,
541,
542,
542,
543,
547,
547,
544,
548,
548,
549,
549,
549,
549,
546,
546,
546,
546,
545,
545,
550,
325,
551,
551,
507,
509,
509,
552,
552,
554,
554,
553,
556,
556,
556,
556,
556,
559,
561,
561,
560,
562,
562,
563,
563,
554,
555,
555,
402,
403,
403,
554,
565,
565,
565,
567,
567,
520,
520,
509,
509,
568,
569,
569,
569,
525,
510,
570,
570,
570,
511,
571,
571,
572,
572,
573,
574,
574,
575,
575,
575,
575,
508,
508,
577,
577,
578,
578,
576,
508,
508,
580,
580,
581,
581,
579,
508,
508,
582,
582,
582,
582,
557,
557,
557,
583,
583,
508,
508,
584,
585,
585,
558,
586,
586,
587,
587,
508,
508,
588,
589,
589,
508,
508,
590,
591,
591,
508,
592,
592,
356,
356,
356,
564,
593,
593,
493,
493,
485,
485,
485,
566,
566,
566,
594,
594,
595,
595,
596,
596,
297,
597,
297,
598,
598,
431,
431,
599,
599,
430,
430,
600,
600,
429,
601,
601,
428,
602,
602,
427,
427,
427,
427,
427,
427,
603,
603,
426,
604,
604,
604,
604,
425,
425,
606,
606,
605,
605,
424,
424,
607,
607,
423,
608,
609,
608,
595,
595,
595,
595,
611,
610,
610,
610,
612,
612,
612,
610,
610,
610,
405,
405,
405,
405,
};
yySymbolRange	yyContinuation	[yyLastReadState + 1] = {
0,
1,
0,
1,
255,
0,
255,
1,
1,
7,
1,
1,
1,
1,
7,
14,
7,
1,
14,
1,
1,
7,
1,
7,
1,
1,
7,
1,
7,
1,
1,
13,
1,
14,
7,
1,
7,
1,
7,
1,
7,
7,
7,
7,
7,
1,
7,
7,
14,
14,
1,
20,
14,
14,
14,
14,
14,
14,
1,
7,
24,
7,
21,
1,
7,
14,
1,
10,
21,
10,
1,
21,
1,
14,
1,
14,
14,
14,
7,
1,
14,
14,
14,
2,
17,
14,
14,
1,
255,
14,
14,
14,
1,
255,
66,
13,
1,
14,
66,
13,
1,
14,
5,
14,
66,
66,
1,
2,
14,
5,
10,
13,
201,
27,
1,
255,
50,
255,
255,
131,
13,
17,
14,
20,
17,
14,
14,
14,
20,
20,
14,
14,
17,
20,
17,
152,
20,
14,
152,
1,
1,
21,
17,
14,
14,
17,
21,
14,
20,
1,
152,
20,
14,
152,
1,
1,
1,
160,
14,
14,
14,
14,
14,
14,
13,
14,
14,
13,
14,
14,
13,
14,
21,
1,
21,
1,
14,
14,
14,
160,
21,
160,
14,
1,
21,
21,
1,
14,
21,
17,
255,
21,
1,
21,
255,
1,
1,
21,
255,
1,
1,
255,
1,
1,
255,
1,
13,
160,
14,
13,
21,
21,
13,
1,
14,
1,
14,
14,
14,
1,
13,
1,
14,
255,
1,
1,
192,
13,
17,
14,
13,
111,
14,
13,
17,
14,
13,
5,
14,
13,
5,
14,
13,
5,
14,
27,
1,
10,
17,
14,
10,
2,
21,
1,
21,
255,
1,
27,
255,
255,
131,
255,
131,
27,
1,
21,
255,
1,
27,
158,
152,
17,
13,
13,
50,
255,
13,
7,
14,
13,
10,
14,
255,
133,
1,
1,
255,
1,
20,
1,
13,
7,
14,
13,
10,
14,
21,
1,
255,
1,
12,
255,
1,
145,
1,
1,
18,
21,
1,
21,
1,
10,
1,
14,
255,
1,
18,
1,
18,
2,
1,
21,
1,
14,
2,
2,
18,
18,
2,
18,
18,
1,
18,
1,
1,
255,
1,
255,
1,
1,
18,
255,
1,
1,
13,
13,
13,
1,
14,
1,
14,
14,
1,
13,
1,
14,
255,
51,
255,
1,
255,
1,
13,
1,
10,
1,
14,
14,
14,
1,
13,
1,
13,
255,
1,
1,
18,
18,
1,
18,
255,
1,
255,
18,
1,
1,
255,
1,
255,
13,
1,
21,
1,
14,
1,
14,
14,
255,
13,
86,
255,
13,
111,
14,
27,
1,
255,
1,
1,
1,
21,
255,
1,
1,
1,
255,
1,
1,
1,
21,
255,
1,
1,
1,
21,
255,
1,
255,
1,
255,
1,
255,
1,
18,
1,
18,
1,
255,
1,
255,
18,
1,
255,
255,
1,
1,
18,
255,
1,
255,
1,
1,
18,
255,
1,
13,
5,
14,
1,
1,
255,
1,
13,
5,
14,
1,
1,
13,
5,
14,
1,
1,
1,
79,
1,
21,
255,
1,
21,
255,
1,
21,
255,
1,
1,
1,
255,
1,
1,
1,
255,
1,
1,
17,
14,
27,
1,
255,
1,
14,
17,
14,
227,
13,
17,
14,
255,
255,
255,
68,
81,
1,
255,
75,
81,
13,
1,
14,
81,
13,
1,
14,
81,
2,
79,
1,
1,
255,
14,
2,
7,
1,
14,
14,
14,
14,
1,
255,
255,
255,
255,
2,
2,
14,
2,
14,
1,
1,
255,
255,
13,
2,
14,
2,
1,
7,
1,
14,
14,
14,
14,
1,
255,
21,
255,
1,
255,
1,
13,
255,
2,
255,
1,
13,
13,
13,
2,
255,
2,
2,
225,
1,
14,
1,
225,
1,
14,
1,
13,
1,
14,
81,
255,
255,
13,
1,
14,
10,
1,
255,
1,
255,
21,
2,
21,
2,
255,
255,
73,
76,
255,
255,
76,
255,
68,
13,
1,
14,
72,
255,
255,
73,
76,
76,
255,
1,
77,
255,
13,
1,
14,
13,
1,
14,
81,
103,
103,
255,
1,
14,
255,
103,
103,
255,
68,
103,
103,
13,
1,
14,
255,
106,
107,
1,
1,
14,
14,
14,
14,
14,
14,
1,
255,
255,
106,
255,
255,
106,
205,
255,
205,
13,
1,
14,
255,
114,
114,
10,
20,
14,
1,
13,
1,
21,
1,
21,
14,
21,
1,
14,
14,
1,
1,
20,
14,
152,
1,
1,
152,
27,
1,
255,
1,
1,
27,
17,
255,
27,
1,
255,
1,
212,
165,
21,
1,
14,
1,
14,
13,
1,
14,
1,
14,
14,
13,
1,
14,
255,
13,
1,
14,
1,
14,
13,
1,
14,
29,
14,
14,
1,
14,
255,
255,
255,
255,
13,
210,
165,
210,
167,
10,
69,
13,
1,
14,
72,
69,
20,
69,
255,
255,
211,
211,
255,
1,
255,
255,
211,
211,
255,
1,
255,
255,
211,
211,
255,
1,
255,
255,
211,
211,
255,
1,
212,
255,
211,
211,
212,
75,
255,
70,
13,
1,
14,
255,
75,
75,
255,
10,
1,
255,
75,
75,
255,
68,
255,
66,
66,
1,
255,
255,
1,
77,
255,
255,
1,
255,
255,
255,
255,
1,
68,
68,
68,
133,
125,
1,
255,
255,
1,
133,
133,
133,
1,
255,
1,
255,
255,
255,
0,
0,
1,
255,
255,
255,
1,
1,
255,
255,
255,
0,
};
unsigned short	yyFinalToProd	[yyLastReadNontermState - yyFirstReadTermState + 1] = {
1481,
1482,
1483,
1484,
1486,
1487,
1488,
1489,
1490,
1491,
1495,
1496,
1497,
1498,
1499,
1500,
1485,
1502,
1501,
1492,
1493,
1494,
1578,
1577,
1579,
1580,
2293,
2294,
2295,
2296,
2283,
2297,
2298,
2289,
2223,
2255,
2240,
2266,
2261,
2258,
2263,
2260,
2262,
2259,
2271,
2272,
2277,
2278,
2281,
2288,
2244,
2245,
2248,
2249,
2252,
2224,
2287,
2235,
2292,
2236,
1575,
1576,
1574,
1573,
1648,
1649,
1647,
1583,
1584,
1560,
1565,
1561,
1592,
1551,
1550,
1582,
1673,
1674,
1675,
1809,
1808,
1606,
1607,
1593,
1503,
1936,
1935,
1504,
1944,
1941,
1976,
1966,
1965,
1969,
1968,
1971,
1970,
1974,
1972,
1977,
1975,
1973,
1959,
1960,
1958,
1929,
1997,
1878,
1992,
1993,
1660,
1657,
1845,
1846,
1847,
1662,
1663,
1664,
1665,
1669,
1670,
1671,
1672,
1659,
1661,
1666,
1667,
1668,
1653,
1642,
1654,
1995,
1994,
1990,
1991,
1833,
1831,
1832,
1731,
1732,
1789,
1506,
1785,
1508,
1754,
1706,
1710,
1711,
1800,
1695,
1694,
1693,
1683,
1747,
1766,
1760,
1902,
1906,
1912,
1908,
1909,
1907,
1911,
1910,
1895,
2136,
2029,
2061,
2062,
2042,
2033,
2105,
2101,
2102,
2096,
2104,
2094,
2049,
2051,
2053,
1540,
2155,
2164,
2145,
2054,
2203,
2193,
2192,
2191,
2126,
2129,
2195,
2200,
2210,
2215,
2216,
1566,
1818,
1480,
1478,
1555,
1554,
2219,
2221,
2220,
2284,
2254,
2276,
2280,
2282,
2286,
2251,
2253,
2275,
2291,
2250,
2268,
2226,
2229,
2231,
2232,
2222,
2238,
2237,
1586,
1587,
1564,
1563,
1521,
1545,
1542,
1588,
1591,
1590,
1589,
1546,
1547,
1549,
1544,
1543,
1816,
1817,
1598,
1605,
1599,
1604,
1594,
1595,
1597,
1601,
1603,
1996,
1937,
1943,
1945,
1939,
1938,
1986,
1934,
1985,
1931,
1932,
1930,
1984,
1963,
1955,
1954,
1951,
1953,
1950,
1988,
1989,
1987,
1874,
1870,
1872,
1869,
1865,
1867,
1949,
1946,
1948,
1924,
1921,
1923,
1925,
1928,
1926,
1998,
1880,
1875,
1877,
1656,
1658,
1644,
1640,
1639,
1651,
1812,
1813,
1806,
1804,
1811,
1851,
1852,
1853,
1854,
1855,
1856,
1857,
1858,
1859,
1981,
1978,
1980,
1983,
1815,
1834,
1835,
1836,
1837,
1838,
1839,
1840,
1841,
1842,
1843,
1830,
1821,
1822,
1701,
1698,
1705,
1703,
1704,
1700,
1697,
1790,
1791,
1782,
1784,
2300,
2302,
1799,
1798,
1796,
2299,
1797,
1793,
1795,
1787,
1723,
1720,
1722,
1753,
1750,
1752,
1715,
1713,
1709,
1707,
1719,
1716,
1718,
1802,
1679,
1676,
1678,
1689,
1692,
1691,
1686,
1687,
1685,
1680,
1682,
2111,
2110,
1850,
1844,
1849,
1771,
1767,
1769,
1736,
1733,
1735,
1781,
1777,
1779,
1776,
1772,
1774,
1730,
1729,
1726,
1727,
1748,
1746,
1745,
1743,
1765,
1762,
1764,
1759,
1756,
1758,
1742,
1738,
1741,
1739,
1737,
1883,
1885,
1916,
1913,
1915,
1920,
1917,
1919,
1890,
1887,
1889,
1894,
1891,
1893,
1899,
1896,
1898,
1901,
1903,
1905,
1615,
1616,
1617,
1618,
1619,
1620,
1621,
1622,
1623,
1624,
1625,
1626,
1627,
1628,
1629,
1630,
1631,
1632,
1633,
1634,
1635,
1636,
1637,
1860,
1861,
1862,
1863,
1864,
1531,
1529,
2039,
2067,
2064,
2035,
2031,
2030,
2098,
2106,
2103,
2084,
2108,
2082,
2078,
2080,
2085,
2086,
2093,
2090,
2089,
2092,
2091,
2088,
2087,
2050,
2052,
2047,
2045,
2154,
2015,
2016,
2017,
2018,
2019,
2020,
2021,
2022,
2023,
2024,
2025,
2026,
2027,
2028,
2068,
2069,
2070,
2071,
2072,
2073,
2074,
2075,
2076,
2147,
2146,
1511,
2003,
2153,
2001,
2152,
2150,
2113,
2157,
1999,
2158,
2166,
2163,
2162,
2159,
2161,
2144,
2143,
2141,
2142,
2140,
2057,
2056,
2174,
2173,
2177,
2171,
2176,
2172,
2184,
2180,
2181,
2178,
2183,
2179,
2205,
2201,
2122,
2128,
2131,
2123,
2124,
2125,
2120,
2190,
2189,
2014,
2117,
2148,
2004,
2005,
2006,
2007,
2008,
2009,
2010,
2011,
2012,
2013,
2114,
2115,
2116,
2198,
2208,
2213,
2149,
2186,
2185,
2197,
2196,
2207,
2206,
2212,
2211,
2134,
2118,
2137,
2119,
1571,
1572,
1530,
1538,
1535,
1534,
1608,
1609,
1611,
1612,
1613,
1614,
1568,
1570,
1828,
1825,
1827,
1824,
1820,
1526,
1525,
1477,
1513,
1514,
1515,
1516,
1517,
1518,
1519,
1522,
1520,
1556,
1553,
};

